euroFormat=(tonumber("1,000")==1); -- redundant but harmless

function LoadData()
	-- load saved settings
end
LoadData()

InventoryPanel=class(Turbine.UI.Control)
function InventoryPanel:Constructor()
	Turbine.UI.Control.Constructor(self)
	self:SetMouseVisible(false);
	self:SetBackground("GaranStuff/AltInventory/Resources/background_mid.jpg");
	self:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self:SetSize(200,200);
	self.characterIndex=1;
	local charIndex;
	for charIndex=1,#characterListArray do
		if characterListArray[charIndex][1]==currentCharacterName then
			self.characterIndex=charIndex;
			break;
		end
	end
	self.characterName=currentCharacterName;

-- create panel controls
	self.FilterCaption=Turbine.UI.Label();
	self.FilterCaption:SetParent(self);
	self.FilterCaption:SetPosition(9,6);
	self.FilterCaption:SetSize(70,20);
	self.FilterCaption:SetFont(fontFace);
	self.FilterCaption:SetForeColor(fontColor);
	self.FilterCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.FilterCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.FilterCaption:SetText(Resource[language][24]..":");

	self.FilterList=GaranStuff.AltInventory.DropDownList();
	self.FilterList:SetParent(self);
	self.FilterList:SetPosition(self.FilterCaption:GetLeft()+self.FilterCaption:GetWidth()+3,self.FilterCaption:GetTop()-3);
	self.FilterList:SetSize(self:GetWidth()-(self.FilterCaption:GetWidth()+self.FilterCaption:GetLeft())-40,20);
	self.FilterList:SetBorderColor(trimColor);
	self.FilterList:SetCurrentBackColor(colorDarkGrey);
	self.FilterList:SetBackColor(backColor);
	self.FilterList:SetTextColor(listTextColor);
	self.FilterList:SetCurrentBackColor(backColor);
	self.FilterList:SetDropRows(6);

	self.SearchCaption=Turbine.UI.Label();
	self.SearchCaption:SetParent(self);
	self.SearchCaption:SetPosition(9,31);
	self.SearchCaption:SetSize(70,20);
	self.SearchCaption:SetFont(fontFace);
	self.SearchCaption:SetForeColor(fontColor);
	self.SearchCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SearchCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SearchCaption:SetText(Resource[language][25]..":");

	self.SearchBorder=Turbine.UI.Control();
	self.SearchBorder:SetParent(self);
	self.SearchBorder:SetPosition(self.SearchCaption:GetLeft()+self.SearchCaption:GetWidth()+2,self.SearchCaption:GetTop()-5);
	self.SearchBorder:SetSize(self:GetWidth()/2-(self.SearchCaption:GetWidth()+self.SearchCaption:GetLeft()),20);
	self.SearchBorder:SetBackColor(Turbine.UI.Color(.15,.25,.45))

	self.SearchText=Turbine.UI.Lotro.TextBox();
	self.SearchText:SetParent(self);
	self.SearchText:SetPosition(self.SearchCaption:GetLeft()+self.SearchCaption:GetWidth()+3,self.SearchCaption:GetTop()-4);
	self.SearchText:SetSize(self:GetWidth()/2-(self.SearchCaption:GetWidth()+self.SearchCaption:GetLeft())-2,18);
	self.SearchText:SetBackColor(Turbine.UI.Color(.25,.35,.55));
	self.SearchText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.SearchText:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.SearchText:SetForeColor(fontColor);
	self.SearchText:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SearchText:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SearchText:SetWantsUpdates(false);
	self.SearchText.Text="";
	self.SearchText.FocusGained=function()
		self.SearchText:SetWantsUpdates(true);
	end
	self.SearchText.FocusLost=function()
		self.SearchText:SetWantsUpdates(false);
	end
	self.SearchText.Update=function()
		if self.SearchText.Text~=self.SearchText:GetText() then
			self.SearchText.Text=self.SearchText:GetText()
			inventoryWindow:LoadInventory(inventoryWindow.CharacterList:GetText());
		end
	end

	self.ShowAllButton=Turbine.UI.Lotro.Button();
	self.ShowAllButton:SetParent(self);
	self.ShowAllButton:SetSize(120,18);
	self.ShowAllButton:SetPosition(self.FilterList:GetLeft()+self.FilterList:GetWidth()-self.ShowAllButton:GetWidth(),self.SearchText:GetTop()-1);
	self.ShowAllButton:SetText(Resource[language][26]);
	self.ShowAllButton.Click=function()
		self.SearchText:SetWantsUpdates(false);
		self.SearchText:SetText("");
		self.FilterList:SetSelectedIndex(1);
		self.FilterList:SelectedIndexChanged(); -- ideally this would fire on it's own, gotta track down a bug in the dropdown list :(
	end

	self.SortCaption=Turbine.UI.Label();
	self.SortCaption:SetParent(self);
	self.SortCaption:SetPosition(9,54);
	self.SortCaption:SetSize(70,20);
	self.SortCaption:SetFont(fontFace);
	self.SortCaption:SetForeColor(fontColor);
	self.SortCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.SortCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.SortCaption:SetText(Resource[language][27]..":");

	self.SortList=DropDownList();
	self.SortList:SetParent(self);
	self.SortList:SetPosition(self.SortCaption:GetLeft()+self.SortCaption:GetWidth()+3,self.SortCaption:GetTop()-3);
	self.SortList:SetSize(self:GetWidth()/2-(self.SortCaption:GetWidth()+self.SortCaption:GetLeft())-1,20);
	self.SortList:SetBorderColor(trimColor);
	self.SortList:SetCurrentBackColor(colorDarkGrey);
	self.SortList:SetBackColor(backColor);
	self.SortList:SetTextColor(listTextColor);
	self.SortList:SetCurrentBackColor(backColor);
	self.SortList:SetDropRows(5);  -- increase as we implement the last 2 options

	self.SortList:AddItem(Resource[language][30],0);
	self.SortList:AddItem(Resource[language][31],1);
	self.SortList:AddItem(Resource[language][32],2);
	self.SortList:AddItem(Resource[language][251],3);
	self.SortList:AddItem(Resource[language][33],4);
	self.SortList:AddItem(Resource[language][34],5); -- did this really serve any use other than a mildly interesting programming exercise?  nope.

	self.DisplayCaption=Turbine.UI.Label();
	self.DisplayCaption:SetParent(self);
	self.DisplayCaption:SetPosition(self:GetWidth()/2+10,54);
	self.DisplayCaption:SetSize(70,20);
	self.DisplayCaption:SetFont(fontFace);
	self.DisplayCaption:SetForeColor(fontColor);
	self.DisplayCaption:SetOutlineColor(Turbine.UI.Color(0,0,0));
	self.DisplayCaption:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.DisplayCaption:SetText(Resource[language][28]..":");

	self.DisplayMode1=Turbine.UI.Control();
	self.DisplayMode1:SetParent(self);
	self.DisplayMode1:SetPosition(self.DisplayCaption:GetLeft()+self.DisplayCaption:GetWidth()+10,52);
	self.DisplayMode1:SetSize(19,19);
	self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
	self.DisplayMode1.MouseClick=function()
		self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Down.jpg");
		self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
		self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
		inventoryWindow.View=1;
		if inventoryWindow:IsVisible() or minimalWindow:IsVisible() then inventoryWindow:LoadInventory(inventoryWindow.CharacterList:GetText()) end;
	end

	self.DisplayMode2=Turbine.UI.Control();
	self.DisplayMode2:SetParent(self);
	self.DisplayMode2:SetPosition(self.DisplayMode1:GetLeft()+self.DisplayMode1:GetWidth()+10,52);
	self.DisplayMode2:SetSize(19,19);
	self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Down.jpg");
	self.DisplayMode2.MouseClick=function()
		self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
		self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Down.jpg");
		self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
		inventoryWindow.View=2;
		if inventoryWindow:IsVisible() or minimalWindow:IsVisible() then inventoryWindow:LoadInventory(inventoryWindow.CharacterList:GetText()) end;
	end

	self.DisplayMode3=Turbine.UI.Control();
	self.DisplayMode3:SetParent(self);
	self.DisplayMode3:SetPosition(self.DisplayMode2:GetLeft()+self.DisplayMode2:GetWidth()+10,52);
	self.DisplayMode3:SetSize(19,19);
	self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
	self.DisplayMode3.MouseClick=function()
		self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
		self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
		self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Down.jpg");
		inventoryWindow.View=3;
		if inventoryWindow:IsVisible() or minimalWindow:IsVisible() then inventoryWindow:LoadInventory(inventoryWindow.CharacterList:GetText()) end;
	end

	self.SortList.SelectedIndexChanged = function ()
		-- reload the display (since displaying the inventory automatically applies the current sort)
		inventoryWindow:LoadInventory(characterListArray[inventoryWindow.CharacterList:GetValue()][1]);
	end

	self:SetVisible(false);

	self.LoadPanelData=function(sender, characterName)
-- handle displaying the "current" character display
	end

	self.SaveData=function()
	end

	self.RemoveCallbacks=function()
		local listIndex
		for listIndex=1,self.InventoryListBackground.InventoryList:GetItemCount() do
			-- first thing we need to do is unregister the old event handlers, since they don't automatically go away when they item does
			if self.InventoryListBackground.InventoryList:GetItem(listIndex).IconCol~=nil and self.InventoryListBackground.InventoryList:GetItem(listIndex).IconCol.GetItem~=nil then
				-- it's an item control that has an item
				RemoveCallback(self.InventoryListBackground.InventoryList:GetItem(listIndex).IconCol:GetItem(),"QuantityChanged",QuantityChanged)
			end
		end
	end

	self.SizeChanged=function(sender,args)
		local newWidth=self:GetWidth();
		local newHeight=self:GetHeight();
		self.FilterList:SetWidth(newWidth-(self.FilterCaption:GetWidth()+self.FilterCaption:GetLeft())-40);
		self.SearchBorder:SetWidth(newWidth/2-(self.SearchCaption:GetWidth()+self.SearchCaption:GetLeft()));
		self.SearchText:SetWidth(self:GetWidth()/2-(self.SearchCaption:GetWidth()+self.SearchCaption:GetLeft())-2);
		self.ShowAllButton:SetLeft(self.FilterList:GetLeft()+self.FilterList:GetWidth()-self.ShowAllButton:GetWidth());

		self.SortList:SetSize(self:GetWidth()/2-(self.SortCaption:GetWidth()+self.SortCaption:GetLeft())-1,self.SortList:GetHeight());
		self.DisplayCaption:SetLeft(self:GetWidth()/2+10);
		self.DisplayMode1:SetLeft(self.DisplayCaption:GetLeft()+self.DisplayCaption:GetWidth()+10);
		self.DisplayMode2:SetLeft(self.DisplayMode1:GetLeft()+self.DisplayMode1:GetWidth()+10);
		self.DisplayMode3:SetLeft(self.DisplayMode2:GetLeft()+self.DisplayMode2:GetWidth()+10);

--		inventoryWindow.InventoryListBackground:SetHeight(height-122);
--		inventoryWindow.InventoryListBackground:SetHeight(newHeight-79);
--		inventoryWindow.InventoryListBackground.InventoryList:SetHeight(inventoryWindow.InventoryListBackground:GetHeight()-2);
--		inventoryWindow.InventoryListBackground.InventoryList.VScrollBar:SetHeight(inventoryWindow.InventoryListBackground:GetHeight()-2);
--		inventoryWindow.InventoryListBackground:SetWidth(width);
--		inventoryWindow.InventoryListBackground.InventoryList:SetWidth(inventoryWindow.InventoryListBackground:GetWidth()-4);
--		local tmpIndex;
--		for tmpIndex=1,inventoryWindow.InventoryListBackground.InventoryList:GetItemCount() do
--			inventoryWindow.InventoryListBackground.InventoryList:GetItem(tmpIndex):SetWidth(inventoryWindow.InventoryListBackground.InventoryList:GetWidth()-2)
--		end
--		inventoryWindow.InventoryListBackground.InventoryList.VScrollBar:SetLeft(inventoryWindow.InventoryListBackground:GetWidth()-16);
--		self.InventoryListBackground:SetHeight(height-263);
		self.InventoryListBackground:SetHeight(newHeight-79);
		self.InventoryListBackground.InventoryList:SetHeight(self.InventoryListBackground:GetHeight()-2);
		self.InventoryListBackground.InventoryList.VScrollBar:SetHeight(self.InventoryListBackground:GetHeight()-2);
		self.InventoryListBackground:SetWidth(newWidth);
		self.InventoryListBackground.InventoryList:SetWidth(self.InventoryListBackground:GetWidth()-4);
		local tmpIndex;

		for tmpIndex=1,self.InventoryListBackground.InventoryList:GetItemCount() do
			self.InventoryListBackground.InventoryList:GetItem(tmpIndex):SetWidth(self.InventoryListBackground.InventoryList:GetWidth()-2)
		end
		self.InventoryListBackground.InventoryList.VScrollBar:SetLeft(self.InventoryListBackground:GetWidth()-16);
	end
	self.SetLanguage=function()
		self.FilterCaption:SetText(Resource[language][24]..":");
		self.SearchCaption:SetText(Resource[language][25]..":");
		self.ShowAllButton:SetText(Resource[language][26]);
		self.SortCaption:SetText(Resource[language][27]..":");
		self.DisplayCaption:SetText(Resource[language][28]..":");
		self.FilterList.ListData:GetItem(1):SetText(Resource[language][29]);
		if self.FilterList.ListData:GetSelectedIndex()==1 then self.FilterList.CurrentValue:SetText(Resource[language][29]) end;
-- filter list values
		local tmpIndex;
		for tmpIndex=1,#self.ItemCategory do
			self.FilterList.ListData:GetItem(tmpIndex+1):SetText(Resource[language][self.ItemCategory[tmpIndex][2]]);
		end
		if self.FilterList.ListData:GetSelectedIndex()==1 then
			self.FilterList.CurrentValue:SetText(Resource[language][29]);
		else
			self.FilterList.CurrentValue:SetText(Resource[language][self.ItemCategory[self.FilterList.ListData:GetSelectedIndex()-1][2]]);
		end

		self.SortList.ListData:GetItem(1):SetText(Resource[language][30]);
		if self.SortList.ListData:GetSelectedIndex()==1 then self.SortList.CurrentValue:SetText(Resource[language][30]) end;
		self.SortList.ListData:GetItem(2):SetText(Resource[language][31]);
		if self.SortList.ListData:GetSelectedIndex()==2 then self.SortList.CurrentValue:SetText(Resource[language][31]) end;
		self.SortList.ListData:GetItem(3):SetText(Resource[language][32]);
		if self.SortList.ListData:GetSelectedIndex()==3 then self.SortList.CurrentValue:SetText(Resource[language][32]) end;
		self.SortList.ListData:GetItem(4):SetText(Resource[language][251]);
		if self.SortList.ListData:GetSelectedIndex()==4 then self.SortList.CurrentValue:SetText(Resource[language][251]) end;
		self.SortList.ListData:GetItem(5):SetText(Resource[language][33]);
		if self.SortList.ListData:GetSelectedIndex()==5 then self.SortList.CurrentValue:SetText(Resource[language][33]) end;
		self.SortList.ListData:GetItem(6):SetText(Resource[language][34]);
		if self.SortList.ListData:GetSelectedIndex()==6 then self.SortList.CurrentValue:SetText(Resource[language][34]) end;
	end
	self.SetTrimColor=function()
		self.FilterList:SetBorderColor(trimColor);
		self.SortList:SetBorderColor(trimColor);
	end
	self.SetBackgroundColor=function()
		self.FilterList:SetBackColor(backColor);
		self.FilterList:SetCurrentBackColor(backColor);
		self.SortList:SetBackColor(backColor);
		self.SortList:SetCurrentBackColor(backColor);
		self.InventoryListBackground.InventoryList:SetBackColor(backColor);
		self.InventoryListBackground.InventoryList.VScrollBar:SetBackColor(backColor);
	end
	self.SetListTextColor=function()
		self.FilterList:SetTextColor( listTextColor );
		self.SortList:SetTextColor( listTextColor );
	end

	self.SetView=function(view)
		if view==1 then
			self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Down.jpg");
		else
			self.DisplayMode1:SetBackground("GaranStuff/AltInventory/Resources/displayListOnly_Up.jpg");
		end
		if view==2 then
			self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Down.jpg");
		else
			self.DisplayMode2:SetBackground("GaranStuff/AltInventory/Resources/displayIconList_Up.jpg");
		end
		if view==3 then
			self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Down.jpg");
		else
			self.DisplayMode3:SetBackground("GaranStuff/AltInventory/Resources/displayIconOnly_Up.jpg");
		end
	end

	self.SetFontColor=function()
		self.FilterCaption:SetForeColor(fontColor);
		self.SearchCaption:SetForeColor(fontColor);
		self.SearchText:SetForeColor(fontColor);
		self.SortCaption:SetForeColor(fontColor);
		self.DisplayCaption:SetForeColor(fontColor);
	end
	self.SetHeadingsColor=function()
	end

	self.SetEnabled=function(state)
		Turbine.UI.Control.SetEnabled(self,state);
		self.FilterList:SetEnabled(state);
		self.SearchText:SetEnabled(state);
		self.ShowAllButton:SetEnabled(state);
		self.SortList:SetEnabled(state);
		self.DisplayMode1:SetMouseVisible(state);
		self.DisplayMode2:SetMouseVisible(state);
		self.DisplayMode3:SetMouseVisible(state);
		self.InventoryListBackground:SetVisible(state);
	end

	self.InventoryListBackground=Turbine.UI.Control();
	self.InventoryListBackground:SetParent(self);
	self.InventoryListBackground:SetPosition(0,78);
	self.InventoryListBackground:SetSize(self:GetWidth(),self:GetHeight()-263);
	self.InventoryListBackground:SetBackColor(Turbine.UI.Color(0,0,0)); -- this one has to stay fixed for grid to show
	self.InventoryListBackground.InventoryList=Turbine.UI.ListBox();
	self.InventoryListBackground.InventoryList:SetParent(self.InventoryListBackground);
	self.InventoryListBackground.InventoryList:SetPosition(2,1);
	self.InventoryListBackground.InventoryList:SetSize(self.InventoryListBackground:GetWidth()-4,self.InventoryListBackground:GetHeight()-2);
	self.InventoryListBackground.InventoryList:SetBackColor(backColor);
	self.InventoryListBackground.InventoryList.VScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.InventoryListBackground.InventoryList.VScrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.InventoryListBackground.InventoryList.VScrollBar:SetParent(self.InventoryListBackground.InventoryList);
	self.InventoryListBackground.InventoryList.VScrollBar:SetBackColor(backColor);
	self.InventoryListBackground.InventoryList.VScrollBar:SetPosition(self.InventoryListBackground:GetWidth()-16,0)
	self.InventoryListBackground.InventoryList.VScrollBar:SetWidth(12);
	self.InventoryListBackground.InventoryList.VScrollBar:SetHeight(self.InventoryListBackground:GetHeight()-2);
	self.InventoryListBackground.InventoryList:SetAllowDrop( false );
	
	self.InventoryListBackground.InventoryList.DragDrop = function( sender, args )
		local shortcut = args.DragDropInfo:GetShortcut();
		if ( shortcut ~= nil ) then
--Turbine.Shell.WriteLine("shrotcut:GetData="..shortcut:GetData());
			-- for now, we don't care which slot it goes in, just put it in the first slot
			inventoryWindow.Backpack:PerformShortcutDrop( shortcut, 1, Turbine.UI.Control.IsShiftKeyDown() );
		end
	end

	self.InventoryListBackground:SetZOrder(4);
	self.InventoryListBackground.InventoryList:SetZOrder(5);
	self.InventoryListBackground.InventoryList.VScrollBar:SetZOrder(6);

	self.SortCaption:SetZOrder(31);
	self.SortList:SetZOrder(32);
	self.DisplayCaption:SetZOrder(34);
	self.DisplayMode1:SetZOrder(36);
	self.DisplayMode2:SetZOrder(38);
	self.DisplayMode3:SetZOrder(40);
	self.SearchCaption:SetZOrder(42);
	self.SearchBorder:SetZOrder(44);
	self.SearchText:SetZOrder(46);
	self.ShowAllButton:SetZOrder(47);
	self.FilterCaption:SetZOrder(48);
	self.FilterList:SetZOrder(50);

	self.ItemCategory={}; -- each element is in the form {turbineValue,text,customCategory} note, displaySequence does not appear as it would have no meaning for ItemCategories

	self.ItemCategory[1]={Turbine.Gameplay.ItemCategory.Undefined,89};
	self.ItemCategory[2]={Turbine.Gameplay.ItemCategory.Bow,90};
	self.ItemCategory[3]={Turbine.Gameplay.ItemCategory.Treasure,91};
	self.ItemCategory[4]={Turbine.Gameplay.ItemCategory.Chest,92};
	self.ItemCategory[5]={Turbine.Gameplay.ItemCategory.Minstrel,93};
	self.ItemCategory[6]={Turbine.Gameplay.ItemCategory.Hands,94};
	self.ItemCategory[7]={Turbine.Gameplay.ItemCategory.Shoulders,95};
	self.ItemCategory[8]={Turbine.Gameplay.ItemCategory.Head,96};
	self.ItemCategory[9]={Turbine.Gameplay.ItemCategory.Mounts,97};
	self.ItemCategory[10]={Turbine.Gameplay.ItemCategory.Pennant,98};
	self.ItemCategory[11]={Turbine.Gameplay.ItemCategory.Dagger,99};
	self.ItemCategory[12]={Turbine.Gameplay.ItemCategory.Instrument,100};
	self.ItemCategory[13]={Turbine.Gameplay.ItemCategory.Axe,101};
	self.ItemCategory[14]={Turbine.Gameplay.ItemCategory.Captain,102};
	self.ItemCategory[15]={Turbine.Gameplay.ItemCategory.Oil,103};
	self.ItemCategory[16]={Turbine.Gameplay.ItemCategory.Legs,104};
	self.ItemCategory[17]={Turbine.Gameplay.ItemCategory.Effect,105};
	self.ItemCategory[18]={Turbine.Gameplay.ItemCategory.Hunter,106};
	self.ItemCategory[19]={Turbine.Gameplay.ItemCategory.Armor,107};
	self.ItemCategory[20]={Turbine.Gameplay.ItemCategory.Loremaster,108};
	self.ItemCategory[21]={Turbine.Gameplay.ItemCategory.Trap,109};
	self.ItemCategory[22]={Turbine.Gameplay.ItemCategory.Decoration,110};
	self.ItemCategory[23]={Turbine.Gameplay.ItemCategory.Champion,111};
	self.ItemCategory[24]={Turbine.Gameplay.ItemCategory.Feet,112};
	self.ItemCategory[25]={Turbine.Gameplay.ItemCategory.Hammer,113};
	self.ItemCategory[26]={Turbine.Gameplay.ItemCategory.Healing,114};
	self.ItemCategory[27]={Turbine.Gameplay.ItemCategory.Guardian,115};
	self.ItemCategory[28]={Turbine.Gameplay.ItemCategory.Quest,116};
	self.ItemCategory[29]={Turbine.Gameplay.ItemCategory.Potion,117};
	self.ItemCategory[30]={Turbine.Gameplay.ItemCategory.Crossbow,118};
	self.ItemCategory[31]={Turbine.Gameplay.ItemCategory.Mace,119};
	self.ItemCategory[32]={Turbine.Gameplay.ItemCategory.Key,120};
	self.ItemCategory[33]={Turbine.Gameplay.ItemCategory.Tool,121};
	self.ItemCategory[34]={Turbine.Gameplay.ItemCategory.Shield,122};
	self.ItemCategory[35]={Turbine.Gameplay.ItemCategory.JourneymanProspectingScroll,123};
	self.ItemCategory[36]={Turbine.Gameplay.ItemCategory.Staff,124};
	self.ItemCategory[37]={Turbine.Gameplay.ItemCategory.Crafting,125};
	self.ItemCategory[38]={Turbine.Gameplay.ItemCategory.Halberd,126};
	self.ItemCategory[39]={Turbine.Gameplay.ItemCategory.Component,127};
	self.ItemCategory[40]={Turbine.Gameplay.ItemCategory.Ingredient,128};
	self.ItemCategory[41]={Turbine.Gameplay.ItemCategory.Clothing,129};
	self.ItemCategory[42]={Turbine.Gameplay.ItemCategory.Club,130};
	self.ItemCategory[43]={Turbine.Gameplay.ItemCategory.Dye,131};
	self.ItemCategory[44]={Turbine.Gameplay.ItemCategory.JourneymanMetalworkScroll,132};
	self.ItemCategory[45]={Turbine.Gameplay.ItemCategory.Weapon,133};
	self.ItemCategory[46]={Turbine.Gameplay.ItemCategory.KinshipCharter,134};
	self.ItemCategory[47]={Turbine.Gameplay.ItemCategory.JourneymanJewellerScroll,135};
	self.ItemCategory[48]={Turbine.Gameplay.ItemCategory.Sword,136};
	self.ItemCategory[49]={Turbine.Gameplay.ItemCategory.Back,137};
	self.ItemCategory[50]={Turbine.Gameplay.ItemCategory.Spear,138};
	self.ItemCategory[51]={Turbine.Gameplay.ItemCategory.Trophy,139};
	self.ItemCategory[52]={Turbine.Gameplay.ItemCategory.Burglar,140};
	self.ItemCategory[53]={Turbine.Gameplay.ItemCategory.Jewelry,141};
	self.ItemCategory[54]={Turbine.Gameplay.ItemCategory.Device,142};
	self.ItemCategory[55]={Turbine.Gameplay.ItemCategory.Relic,143};
	self.ItemCategory[56]={Turbine.Gameplay.ItemCategory.Book,144};
	self.ItemCategory[57]={Turbine.Gameplay.ItemCategory.NonInventory,145};
	self.ItemCategory[58]={Turbine.Gameplay.ItemCategory.Thrown,146};
	self.ItemCategory[59]={Turbine.Gameplay.ItemCategory.Food,147};
	self.ItemCategory[60]={Turbine.Gameplay.ItemCategory.Resource,148};
	self.ItemCategory[61]={Turbine.Gameplay.ItemCategory.Scroll,149};
	self.ItemCategory[62]={Turbine.Gameplay.ItemCategory.ApprenticeTailorScroll,150};
	self.ItemCategory[63]={Turbine.Gameplay.ItemCategory.ApprenticeJewellerScroll,151};
	self.ItemCategory[64]={Turbine.Gameplay.ItemCategory.ApprenticeProspectingScroll,152};
	self.ItemCategory[65]={Turbine.Gameplay.ItemCategory.ApprenticeFarmerScroll,153};
	self.ItemCategory[66]={Turbine.Gameplay.ItemCategory.ApprenticeScholarScroll,154};
	self.ItemCategory[67]={Turbine.Gameplay.ItemCategory.ApprenticeForestryScroll,155};
	self.ItemCategory[68]={Turbine.Gameplay.ItemCategory.ApprenticeMetalworkScroll,156};
	self.ItemCategory[69]={Turbine.Gameplay.ItemCategory.ApprenticeCookScroll,157};
	self.ItemCategory[70]={Turbine.Gameplay.ItemCategory.ApprenticeWeaponsmithScroll,158};
	self.ItemCategory[71]={Turbine.Gameplay.ItemCategory.ApprenticeWoodworkScroll,159};
	self.ItemCategory[72]={Turbine.Gameplay.ItemCategory.MusicDecoration,160};
	self.ItemCategory[73]={Turbine.Gameplay.ItemCategory.SurfacePaintDecoration,161};
	self.ItemCategory[74]={Turbine.Gameplay.ItemCategory.TrophyDecoration,162};
	self.ItemCategory[75]={Turbine.Gameplay.ItemCategory.FurnitureDecoration,163};
	self.ItemCategory[76]={Turbine.Gameplay.ItemCategory.FloorDecoration,164};
	self.ItemCategory[77]={Turbine.Gameplay.ItemCategory.YardDecoration,165};
	self.ItemCategory[78]={Turbine.Gameplay.ItemCategory.WallDecoration,166};
	self.ItemCategory[79]={Turbine.Gameplay.ItemCategory.Implement,167};
	self.ItemCategory[80]={Turbine.Gameplay.ItemCategory.CosmeticHeld,168};
	self.ItemCategory[81]={Turbine.Gameplay.ItemCategory.CosmeticBack,169};
	self.ItemCategory[82]={Turbine.Gameplay.ItemCategory.SpecialDecoration,170};
	self.ItemCategory[83]={Turbine.Gameplay.ItemCategory.CeilingDecoration,171};
	self.ItemCategory[84]={Turbine.Gameplay.ItemCategory.FishingBait,172};
	self.ItemCategory[85]={Turbine.Gameplay.ItemCategory.FishingOther,173};
	self.ItemCategory[86]={Turbine.Gameplay.ItemCategory.Fish,174};
	self.ItemCategory[87]={Turbine.Gameplay.ItemCategory.FishingPole,175};
	self.ItemCategory[88]={Turbine.Gameplay.ItemCategory.Orb,176};
	self.ItemCategory[89]={Turbine.Gameplay.ItemCategory.Warden,177};
	self.ItemCategory[90]={Turbine.Gameplay.ItemCategory.Runekeeper,178};
	self.ItemCategory[91]={Turbine.Gameplay.ItemCategory.LegendaryWeaponExperience,179};
	self.ItemCategory[92]={Turbine.Gameplay.ItemCategory.LegendaryWeaponReset,180};
	self.ItemCategory[93]={Turbine.Gameplay.ItemCategory.Deconstructable,181};
	self.ItemCategory[94]={Turbine.Gameplay.ItemCategory.Javelin,182};
	self.ItemCategory[95]={Turbine.Gameplay.ItemCategory.GuardianBelt,183};
	self.ItemCategory[96]={Turbine.Gameplay.ItemCategory.JourneymanCookScroll,184};
	self.ItemCategory[97]={Turbine.Gameplay.ItemCategory.ExpertCookScroll,185};
	self.ItemCategory[98]={Turbine.Gameplay.ItemCategory.ArtisanCookScroll,186};
	self.ItemCategory[99]={Turbine.Gameplay.ItemCategory.MasterCookScroll,187};
	self.ItemCategory[100]={Turbine.Gameplay.ItemCategory.SupremeCookScroll,188};
	self.ItemCategory[101]={Turbine.Gameplay.ItemCategory.MasterWoodworkScroll,189};
	self.ItemCategory[102]={Turbine.Gameplay.ItemCategory.MasterWeaponsmithScroll,190};
	self.ItemCategory[103]={Turbine.Gameplay.ItemCategory.ArtisanTailorScroll,191};
	self.ItemCategory[104]={Turbine.Gameplay.ItemCategory.ExpertFarmerScroll,192};
	self.ItemCategory[105]={Turbine.Gameplay.ItemCategory.JourneymanForestryScroll,193};
	self.ItemCategory[106]={Turbine.Gameplay.ItemCategory.SupremeWoodworkScroll,194};
	self.ItemCategory[107]={Turbine.Gameplay.ItemCategory.SupremeWeaponsmithScroll,195};
	self.ItemCategory[108]={Turbine.Gameplay.ItemCategory.MasterTailorScroll,196};
	self.ItemCategory[109]={Turbine.Gameplay.ItemCategory.ArtisanFarmerScroll,197};
	self.ItemCategory[110]={Turbine.Gameplay.ItemCategory.ExpertForestryScroll,198};
	self.ItemCategory[111]={Turbine.Gameplay.ItemCategory.SupremeTailorScroll,199};
	self.ItemCategory[112]={Turbine.Gameplay.ItemCategory.MasterFarmerScroll,200};
	self.ItemCategory[113]={Turbine.Gameplay.ItemCategory.ArtisanForestryScroll,201};
	self.ItemCategory[114]={Turbine.Gameplay.ItemCategory.SupremeFarmerScroll,202};
	self.ItemCategory[115]={Turbine.Gameplay.ItemCategory.MasterForestryScroll,203};
	self.ItemCategory[116]={Turbine.Gameplay.ItemCategory.SupremeForestryScroll,204};
	self.ItemCategory[117]={Turbine.Gameplay.ItemCategory.ExpertProspectingScroll,205};
	self.ItemCategory[118]={Turbine.Gameplay.ItemCategory.ArtisanProspectingScroll,206};
	self.ItemCategory[119]={Turbine.Gameplay.ItemCategory.MasterProspectingScroll,207};
	self.ItemCategory[120]={Turbine.Gameplay.ItemCategory.SupremeProspectingScroll,208};
	self.ItemCategory[121]={Turbine.Gameplay.ItemCategory.JourneymanScholarScroll,209};
	self.ItemCategory[122]={Turbine.Gameplay.ItemCategory.ExpertScholarScroll,210};
	self.ItemCategory[123]={Turbine.Gameplay.ItemCategory.ArtisanScholarScroll,211};
	self.ItemCategory[124]={Turbine.Gameplay.ItemCategory.ExpertMetalworkScroll,212};
	self.ItemCategory[125]={Turbine.Gameplay.ItemCategory.MasterScholarScroll,213};
	self.ItemCategory[126]={Turbine.Gameplay.ItemCategory.ExpertJewellerScroll,214};
	self.ItemCategory[127]={Turbine.Gameplay.ItemCategory.JourneymanWoodworkScroll,215};
	self.ItemCategory[128]={Turbine.Gameplay.ItemCategory.JourneymanWeaponsmithScroll,216};
	self.ItemCategory[129]={Turbine.Gameplay.ItemCategory.ArtisanMetalworkScroll,217};
	self.ItemCategory[130]={Turbine.Gameplay.ItemCategory.SupremeScholarScroll,218};
	self.ItemCategory[131]={Turbine.Gameplay.ItemCategory.ArtisanJewellerScroll,219};
	self.ItemCategory[132]={Turbine.Gameplay.ItemCategory.ExpertWoodworkScroll,220};
	self.ItemCategory[133]={Turbine.Gameplay.ItemCategory.ExpertWeaponsmithScroll,221};
	self.ItemCategory[134]={Turbine.Gameplay.ItemCategory.MasterMetalworkScroll,222};
	self.ItemCategory[135]={Turbine.Gameplay.ItemCategory.JourneymanTailorScroll,223};
	self.ItemCategory[136]={Turbine.Gameplay.ItemCategory.MasterJewellerScroll,224};
	self.ItemCategory[137]={Turbine.Gameplay.ItemCategory.ArtisanWoodworkScroll,225};
	self.ItemCategory[138]={Turbine.Gameplay.ItemCategory.ArtisanWeaponsmithScroll,226};
	self.ItemCategory[139]={Turbine.Gameplay.ItemCategory.SupremeMetalworkScroll,227};
	self.ItemCategory[140]={Turbine.Gameplay.ItemCategory.ExpertTailorScroll,228};
	self.ItemCategory[141]={Turbine.Gameplay.ItemCategory.SupremeJewellerScroll,229};
	self.ItemCategory[142]={Turbine.Gameplay.ItemCategory.JourneymanFarmerScroll,230};
	self.ItemCategory[143]={Turbine.Gameplay.ItemCategory.MinstrelBook,231};
	self.ItemCategory[144]={Turbine.Gameplay.ItemCategory.Misc,232};
	self.ItemCategory[145]={Turbine.Gameplay.ItemCategory.LegendaryWeaponReplaceLegacy,233};
	self.ItemCategory[146]={Turbine.Gameplay.ItemCategory.LegendaryWeaponIncreaseMaxLevel,234};
	self.ItemCategory[147]={Turbine.Gameplay.ItemCategory.LegendaryWeaponUpgradeLegacy,235};
	self.ItemCategory[148]={Turbine.Gameplay.ItemCategory.CraftingTrophy,236};
-- loremaster food is labelled "Loremaster Class Item" but is indeed a distinct category, thus the possibility of multiple entries with the same name
-- I have not attempted to merge these two entries since the built in Vault does not either
	self.ItemCategory[149]={Turbine.Gameplay.ItemCategory.LoremasterFood,237};
	self.ItemCategory[150]={Turbine.Gameplay.ItemCategory.SpecialTrophy,238};
	-- here's the undefined ones that I have found so far...
	self.ItemCategory[151]={89,239};
	self.ItemCategory[152]={177,240};
	self.ItemCategory[153]={178,241};
	self.ItemCategory[154]={182,242};
	self.ItemCategory[155]={183,243};
	self.ItemCategory[156]={186,244};
	self.ItemCategory[157]={188,245};
	self.ItemCategory[158]={189,246};
	self.ItemCategory[159]={191,247};
	self.ItemCategory[160]={173,248};
	self.ItemCategory[161]={180,249};
	self.ItemCategory[162]={187,253};
	self.ItemCategory[163]={179,254};
	for tmpIndex=1,#self.ItemCategory do
		self.ItemCategory[tmpIndex][3]=Resource[language][self.ItemCategory[tmpIndex][2]];
	end

	table.sort(self.ItemCategory,function(arg1,arg2) return(arg1[3]<arg2[3]) end)

	self.FilterList:AddItem(Resource[language][29],-1);

	for tmpIndex=1,#self.ItemCategory do
		if self.ItemCategory[tmpIndex][1]==Turbine.Gameplay.ItemCategory.Undefined then
			undefinedCategoryIndex=tmpIndex+1; -- need to keep track of where the "undefined" category winds up in the list
		end
		categorySortOrder[self.ItemCategory[tmpIndex][1]]=tmpIndex;
		self.FilterList:AddItem(self.ItemCategory[tmpIndex][3],self.ItemCategory[tmpIndex][1]);
	end

	self.FilterList.SelectedIndexChanged = function ()
		inventoryWindow:LoadInventory(inventoryWindow.CharacterList:GetText());
	end
end
