-- Generic Panel skeleton

euroFormat=(tonumber("1,000")==1); -- redundant but harmless

function LoadData()
	FactionRep=PatchDataLoad( Turbine.DataScope.Server, "AltInventory_FactionRep");
	if FactionRep==nil then
		FactionRep={};
	end
end
LoadData();

Faction={};
Faction[1]={1,"The Ale Association",false,1};
Faction[2]={2,"The Eldgang",false,1};
Faction[3]={3,"Council of the North",false,1};
Faction[4]={4,"Men of Bree",false,1};
Faction[5]={5,"Algraig, Men of Enedwaith",false,1};
Faction[6]={6,"The Grey Company",false,1};
Faction[7]={7,"Thorin's Hall",false,1};
Faction[8]={8,"The Wardens of Ann"..string.char(195)..string.char(186).."minas",false,1};
Faction[9]={9,"Lossoth of Forochel",false,1};
Faction[10]={10,"The Eglain",false,1};
Faction[11]={11,"Galaghrim",false,1};
Faction[12]={12,"Malledhrim",false,1};
Faction[13]={13,"Rangers of Esteld"..string.char(195)..string.char(173).."n",false,1};
Faction[14]={14,"Elves of Rivendell",false,1};
Faction[15]={15,"The Mathom Society",false,1};
Faction[16]={16,"The Inn League",false,1};
Faction[17]={17,"Iron Garrison Guards",false,1};
Faction[18]={18,"Iron Garrison Miners",false,1};
Faction[19]={19,"Men of Dunland",false,1};
Faction[20]={20,"Th"..string.char(195)..string.char(169).."odred's Riders",false,1};
Faction[21]={21,"Guild",true,2};

CraftGuild={"<Select Guild>","Cook's Guild","Jeweller's Guild","Metalsmith's Guild","Scholar's Guild","Tailor's Guild","Weaponsmith's Guild","Woodworker's Guild"};
FactionTier={}
FactionTier[1]={"Outsider","Neutral","Acquaintance","Friend","Ally","Kindred"};
FactionTier[2]={"Apprentice of the Guild","Journeyman of the Guild","Expert of the Guild","Artisan of the Guild","Master of the Guild"}; -- Guild Tiers are different

RepPanel=class(Turbine.UI.Control)
function RepPanel:Constructor()
	Turbine.UI.Control.Constructor(self)
	self:SetMouseVisible(false);
	self:SetBackColor(backColor);
	self:SetSize(200,200);
	self.characterIndex=1;
	local charIndex;
	for charIndex=1,#characterListArray do
		if characterListArray[charIndex][1]==currentCharacterName then
			self.characterIndex=charIndex;
			break;
		end
	end
	self.characterName=currentCharacterName;

-- create panel controls
	self.VP=Turbine.UI.Label();
	self.VP:SetSize(190,60*#Faction+100); -- we pad the bottom by 100 to allow enough room for the drop down lists
	self.VP:SetParent(self);
	self.GuildFaction=20;
	self.FactionCaption={};
	self.FactionList={};
	for tmpIndex=1,#Faction do
		if Faction[tmpIndex][3] then
			self.GuildFaction=tmpIndex;
			self.FactionCaption[tmpIndex]=DropDownList();
			for tmpGuild=1,#CraftGuild do
				self.FactionCaption[tmpIndex]:AddItem(CraftGuild[tmpGuild],tmpGuild);
			end
			self.FactionCaption[tmpIndex]:SetBorderColor(backColor);
			self.FactionCaption[tmpIndex]:SetBackColor(backColor);
			self.FactionCaption[tmpIndex]:SetTextColor(listTextColor);
			self.FactionCaption[tmpIndex]:SetCurrentBackColor(backColor);
			self.FactionCaption[tmpIndex].CurrentValue:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);
			self.FactionCaption[tmpIndex]:SetSelectedIndex(1);
			self.FactionCaption[tmpIndex].SelectedIndexChanged=function(sender,args)
				FactionRep[self.characterName]["Guild"]=self.FactionCaption[self.GuildFaction]:GetValue()-1;
				self.FactionList[self.GuildFaction]:SetVisible((FactionRep[self.characterName]["Guild"]~=0));
			end
		else
			self.FactionCaption[tmpIndex]=Turbine.UI.Label();
			self.FactionCaption[tmpIndex]:SetHeight(25);
			self.FactionCaption[tmpIndex]:SetText(Faction[tmpIndex][2]);
			self.FactionCaption[tmpIndex]:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);
		end
		self.FactionCaption[tmpIndex]:SetParent(self.VP);
		self.FactionCaption[tmpIndex]:SetPosition(0,(tmpIndex-1)*60);
		self.FactionCaption[tmpIndex]:SetWidth(self:GetWidth()-12);
		self.FactionCaption[tmpIndex]:SetFont(Turbine.UI.Lotro.Font.Verdana16);

		self.FactionList[tmpIndex]=DropDownList();
		self.FactionList[tmpIndex]:SetParent(self.VP);
		self.FactionList[tmpIndex]:SetWidth(self:GetWidth()-12);
		self.FactionList[tmpIndex]:SetFont(Turbine.UI.Lotro.Font.Verdana14);
		self.FactionList[tmpIndex]:SetPosition(0,(tmpIndex-1)*60+25);
		self.FactionList[tmpIndex]:SetBorderColor(trimColor);
		self.FactionList[tmpIndex]:SetBackColor(backColor);
		self.FactionList[tmpIndex]:SetTextColor(listTextColor);
		self.FactionList[tmpIndex]:SetCurrentBackColor(backColor);
		self.FactionList[tmpIndex].FactionID=Faction[tmpIndex][1]; -- just in case we need to add a faction within the display order
		self.FactionList[tmpIndex]:AddItem("<Select>",0);

		local tmpTier
		for tmpTier=1,#FactionTier[Faction[tmpIndex][4]] do
			self.FactionList[tmpIndex]:AddItem(FactionTier[Faction[tmpIndex][4]][tmpTier],tmpTier);
		end

		self.FactionList[tmpIndex]:SetDropRows(#FactionTier[Faction[tmpIndex][4]]+1);
		self.FactionList[tmpIndex]:SetSelectedIndex(1);
		self.FactionList[tmpIndex].SelectedIndexChanged=function(sender,args)
			-- update the FactionRep table
			FactionRep[self.characterName]["Rep"][sender.FactionID]=sender:GetValue();
		end
	end
	
	self.VScroll=Turbine.UI.Lotro.ScrollBar();
	self.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.VScroll:SetParent(self);
	self.VScroll:SetBackColor(backColor);
	self.VScroll:SetPosition(self:GetWidth()-12,0);
	self.VScroll:SetWidth(12);
	self.VScroll:SetHeight(200);
	self.VScroll:SetMinimum(0);
	self.VScroll.ValueChanged=function(sender,args)
		self.VP:SetTop(-self.VScroll:GetValue());
	end

	self:SetVisible(false);

	self.IsValid=function()
		return (characterListArray[self.characterIndex][9]==Turbine.Gameplay.Alignment.FreePeople);
	end
	self.LoadPanelData=function(sender, characterName)
		local charIndex;
		for charIndex=1,#characterListArray do
			if characterListArray[charIndex][1]==characterName then
				self.characterIndex=charIndex;
				if inventoryWindow~=nil and inventoryWindow.PanelShowing==self.Index then
					self:SetVisible(self:IsValid())
				end
				break;
			end
		end
		self.characterName=characterName;
		if FactionRep[characterName]==nil then
			FactionRep[characterName]={};
			FactionRep[characterName]["Guild"]=0; -- undefined - there is no Prospector or Forester guild
			FactionRep[characterName]["Rep"]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		end

		local tmpIndex;
		for tmpIndex=1,#Faction do
			if Faction[tmpIndex][3] then
				-- guild faction, treat it "specially"
				local guild=FactionRep[characterName]["Guild"];
				self.FactionCaption[tmpIndex]:SetSelectedIndex(guild+1);
				self.FactionList[tmpIndex]:SetVisible((guild~=0));
			end
			if FactionRep[characterName]["Rep"][self.FactionList[tmpIndex].FactionID]~=nil then
				self.FactionList[tmpIndex]:SetSelectedIndex(FactionRep[characterName]["Rep"][self.FactionList[tmpIndex].FactionID]+1);
			else
				self.FactionList[tmpIndex]:SetSelectedIndex(1);
			end
		end
	end

	self.SaveData=function()
		PatchDataSave( Turbine.DataScope.Server, "AltInventory_FactionRep",FactionRep);
	end

	self.RemoveCallbacks=function()
		RemoveCallback(Turbine.Chat,"Received",self.ChatHandler);
	end

	self.SizeChanged=function(sender,args)
		local newWidth=self:GetWidth();
		local newHeight=self:GetHeight();
		self.VScroll:SetLeft(newWidth-12);
		self.VScroll:SetHeight(newHeight);
		self.VP:SetWidth(newWidth-12);
		local tmpIndex;
		for tmpIndex=1,#Faction do
			self.FactionCaption[tmpIndex]:SetWidth(newWidth-12);
			self.FactionList[tmpIndex]:SetWidth(newWidth-12);
		end
		if self.VScroll:GetValue()>self.VScroll:GetMaximum() then
			self.VSCroll:SetValue(self.VSCroll:GetMaximum());
		end
		if self:GetHeight()<self.VP:GetHeight() then
			self.VScroll:SetMaximum(self.VP:GetHeight()-self:GetHeight());
			self.VP:SetTop(-self.VScroll:GetValue());
			self.VScroll:SetVisible(true);
		else
			self.VScroll:SetValue(0);
			self.VScroll:SetVisible(false);
		end
	end
	self.SetLanguage=function()
	end
	self.SetTrimColor=function()
		local tmpIndex;
		for tmpIndex=1,#Faction do
			if Faction[tmpIndex][3] then
				self.FactionCaption[tmpIndex]:SetBorderColor(trimColor);
			end
			self.FactionList[tmpIndex]:SetBorderColor(trimColor);
		end
	end
	self.SetBackgroundColor=function()
		for tmpIndex=1,#Faction do
			if Faction[tmpIndex][3] then
				self.FactionCaption[tmpIndex]:SetBackColor(backColor);
				self.FactionCaption[tmpIndex]:SetCurrentBackColor(backColor);
			end
			self.FactionList[tmpIndex]:SetBackColor(backColor);
			self.FactionList[tmpIndex]:SetCurrentBackColor(backColor);
		end
	end
	self.SetListTextColor=function()
		local tmpIndex;
		for tmpIndex=1,#Faction do
			if Faction[tmpIndex][3] then
				self.FactionCaption[tmpIndex]:SetTextColor(listTextColor);
			end
			self.FactionList[tmpIndex]:SetTextColor(listTextColor);
		end
	end
	self.SetFontColor=function()
	end
	self.SetHeadingsColor=function()
	end
	for tmpIndex=1,#Faction do
		if Faction[tmpIndex][3] then
			self.FactionCaption[tmpIndex]:SetZOrder((#Faction-tmpIndex)*2+2)
		end
		self.FactionList[tmpIndex]:SetZOrder((#Faction-tmpIndex)*2+1)
	end
-- add a chat listener on Advancement messages for the form of:
-- advancementPattern="Your standing with (.*) is now (.*)%..*"
	local advancementPattern;
	if _locale=="en" then
		advancementPattern="Your standing with (.*) is now (.*)%..*";
	elseif _locale=="fr" then
		advancementPattern="Your standing with (.*) is now (.*)%..*";
	else
		advancementPattern="Your standing with (.*) is now (.*)%..*";
	end
	self.ChatHandler=function(sender,args)
		if args.ChatType==Turbine.ChatType.Advancement or args.ChatType==Turbine.ChatType.Standard then
			local faction,tier=string.match(args.Message,advancementPattern);
			if faction~=nil then
				-- whooohooo! we got a faction advancement message!
				-- gonna be hard to test this one :(  perhaps create a new character for each test and use up the rep items in the shared vault
				local tmpIndex,factionID,tierID;
				for tmpIndex=1,#Faction do
					if Faction[tmpIndex][2]==faction then
						factionID=Faction[tmpIndex][1];
						break;
					end
				end
				if factionID~=nil then
					for tmpIndex=1,#FactionTier[Faction[factionID][4]] do
						if FactionTier[Faction[factionID][4]][tmpIndex]==tier then
							tierID=tmpIndex;
							break;
						end
					end
					if tierID~=nil then
						FactionRep[currentCharacterName]["Rep"][factionID]=tierID
						if self.characterName==currentCharacterName then
							self:LoadPanelData(currentCharacterName)
						end
					end
				end
			end
		end
	end
	AddCallback(Turbine.Chat,"Received",self.ChatHandler);
end
