TrackingWindow = class(Turbine.UI.Lotro.Window);
local trackingBackPack;
function TrackingWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetText(Resource[language][35]);
	self:SetVisible(false);
	self.ShowIconsInList=true;
	self.DefaultCharLowThreshold=5;
	self.DefaultCharCriticalThreshold=1;
	self.DefaultAllLowThreshold=40;
	self.DefaultAllCriticalThreshold=8;
	self.NeedsQtyUpdate=false;
	self:SetOpacity(1);
	local height=405;
	local width=390; -- 8 columns
	local left=(Turbine.UI.Display:GetWidth() - width) / 2;
	local top=(Turbine.UI.Display:GetHeight() - height) / 2;
	local tmpSettings;
	tmpSettings=PatchDataLoad(Turbine.DataScope.Character, "AltInventorySettings");
	if (tmpSettings~=nil) then
		local index;
		for index=1,#tmpSettings do
			if tmpSettings[index]~=nil then
				if (tmpSettings[index][1]=="ITTop") then
					top=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="ITLeft") then
					left=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="ITHeight") then
					height=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="ITWidth") then
					width=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="ITShowIconsInList") then
					self.ShowIconsInList=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="ITDefaultCharLowThreshold") then
					self.DefaultCharLowThreshold=tmpSettings[index][2];
				elseif (tmpSettings[index][1]=="ITDefaultCharCriticalThreshold") then
					self.DefaultCharCriticalThreshold=tmpSettings[index][2];
				end
			end
		end
		-- account for changed resolution
		if left>(Turbine.UI.Display.GetWidth()-width) then left=Turbine.UI.Display.GetWidth()-width end;
		if left<0 then left=0 end;
		if width>(Turbine.UI.Display.GetWidth()-left) then width=Turbine.UI.Display.GetWidth()-left end;
		if top>(Turbine.UI.Display.GetHeight()-height) then top=Turbine.UI.Display.GetHeight()-height end;
		if top<0 then top=0 end;
		if height>(Turbine.UI.Display.GetHeight()-top) then height=Turbine.UI.Display.GetHeight()-top end;
	end
	tmpSettings=PatchDataLoad(Turbine.DataScope.Server, "AltInventorySettings");
	if (tmpSettings~=nil) then
		local index;
		for index=1,#tmpSettings do
			if (tmpSettings[index][1]=="ITDefaultAllLowThreshold") then
				self.DefaultAllLowThreshold=tmpSettings[index][2];
			elseif (tmpSettings[index][1]=="ITDefaultAllCriticalThreshold") then
				self.DefaultAllCriticalThreshold=tmpSettings[index][2];
			end
		end
	end

	self.TrackMenu=Turbine.UI.ContextMenu()
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][46]));
	self.TrackMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][37]));

	self.QuantityMenu=Turbine.UI.ContextMenu()

	self:SetSize(width,height);
	self:SetPosition(left,top);

	self.Background=Turbine.UI.Label();
	self.Background:SetParent(self);
	self.Background:SetSize(self:GetWidth()-40,self:GetHeight()-55);
	self.Background:SetPosition(20,34)
	self.Background:SetBackColor(Turbine.UI.Color(0,0,0));

	self.CharTab=Turbine.UI.Label();
	self.CharTab:SetParent(self.Background);
	self.CharTab:SetPosition(0,0);
	self.CharTab:SetSize(65,20);
	self.CharTab:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.CharTab:SetForeColor(Turbine.UI.Color(.80,.60,.1));
	self.CharTab:SetOutlineColor(Turbine.UI.Color(.05,.05,.1));
	self.CharTab:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.CharTab:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.CharTab:SetBackground("GaranStuff/AltInventory/Resources/TrackTabUp.tga");
	self.CharTab:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
	self.CharTab:SetText(Resource[language][36]);

	self.AllTab=Turbine.UI.Label();
	self.AllTab:SetParent(self.Background);
	self.AllTab:SetPosition(self.CharTab:GetLeft()+self.CharTab:GetWidth(),self.CharTab:GetTop());
	self.AllTab:SetSize(65,20);
	self.AllTab:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.AllTab:SetForeColor(Turbine.UI.Color(.80,.60,.1));
	self.AllTab:SetOutlineColor(Turbine.UI.Color(.05,.05,.1));
	self.AllTab:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.AllTab:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	self.AllTab:SetBackground("GaranStuff/AltInventory/Resources/TrackTabDown.tga");
	self.AllTab:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
	self.AllTab:SetText(Resource[language][29]);

	self.CharTrackPanel=Turbine.UI.Label();
	self.CharTrackPanel:SetParent(self.Background);
	self.CharTrackPanel:SetPosition(0,18);
	self.CharTrackPanel:SetSize(self:GetWidth()-40,self:GetHeight()-73);
	self.CharTrackPanel:SetVisible(true);
	self.CharTrackPanel:SetBackColor(Turbine.UI.Color(.75,.75,.75));-- make "Char" silver

	self.AllTrackPanel=Turbine.UI.Label();
	self.AllTrackPanel:SetParent(self.Background);
	self.AllTrackPanel:SetPosition(self.CharTrackPanel:GetLeft(),self.CharTrackPanel:GetTop());
	self.AllTrackPanel:SetSize(self.CharTrackPanel:GetWidth(),self.CharTrackPanel:GetHeight());
	self.AllTrackPanel:SetVisible(false);
	self.AllTrackPanel:SetBackColor(Turbine.UI.Color(.80,.60,.1));-- make "All" gold

	self.CharTab.MouseClick=function()
		self.CharTab:SetBackground("GaranStuff/AltInventory/Resources/TrackTabUp.tga");
		self.CharTab:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
		self.AllTab:SetBackground("GaranStuff/AltInventory/Resources/TrackTabDown.tga");
		self.AllTab:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
		self.CharTrackPanel:SetVisible(true);
		self.AllTrackPanel:SetVisible(false);
	end
	self.AllTab.MouseClick=function()
		self.AllTab:SetBackground("GaranStuff/AltInventory/Resources/TrackTabUp.tga");
		self.AllTab:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
		self.CharTab:SetBackground("GaranStuff/AltInventory/Resources/TrackTabDown.tga");
		self.CharTab:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter);
		self.AllTrackPanel:SetVisible(true);
		self.CharTrackPanel:SetVisible(false);
	end

	self.CharItemList=Turbine.UI.ListBox();
	self.CharItemList:SetParent(self.CharTrackPanel);
	self.CharItemList:SetPosition(1,1);
	self.CharItemList:SetSize(self.CharTrackPanel:GetWidth()-2,self.CharTrackPanel:GetHeight()-2);
	self.CharItemList:SetBackColor(Turbine.UI.Color(0,0,0));
	self.CharItemList.VScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.CharItemList.VScrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.CharItemList.VScrollBar:SetParent(self.CharItemList);
	self.CharItemList.VScrollBar:SetBackColor(Turbine.UI.Color(0,0,0));
	self.CharItemList.VScrollBar:SetPosition(self.CharItemList:GetWidth()-12,0)
	self.CharItemList.VScrollBar:SetWidth(12);
	self.CharItemList.VScrollBar:SetHeight(self.CharItemList:GetHeight());
	self.CharItemList.VScrollBar:SetVisible(false);
	self.CharItemList:SetVerticalScrollBar(self.CharItemList.VScrollBar);
	self.CharItemList.VScrollBar:SetZOrder(self.CharItemList:GetZOrder()+1);

	self.AllItemList=Turbine.UI.ListBox();
	self.AllItemList:SetParent(self.AllTrackPanel);
	self.AllItemList:SetPosition(1,1);
	self.AllItemList:SetSize(self.AllTrackPanel:GetWidth()-2,self.AllTrackPanel:GetHeight()-2);
	self.AllItemList:SetBackColor(Turbine.UI.Color(0,0,0));
	self.AllItemList.VScrollBar=Turbine.UI.Lotro.ScrollBar();
	self.AllItemList.VScrollBar:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.AllItemList.VScrollBar:SetParent(self.AllItemList);
	self.AllItemList.VScrollBar:SetBackColor(Turbine.UI.Color(0,0,0));
	self.AllItemList.VScrollBar:SetPosition(self.AllItemList:GetWidth()-12,0)
	self.AllItemList.VScrollBar:SetWidth(12);
	self.AllItemList.VScrollBar:SetHeight(self.AllItemList:GetHeight());
	self.AllItemList.VScrollBar:SetVisible(false);
	self.AllItemList:SetVerticalScrollBar(self.AllItemList.VScrollBar);
	self.AllItemList.VScrollBar:SetZOrder(self.AllItemList:GetZOrder()+1);

	self.CharItemArray={};
	self.AllItemArray={};

	self.AddItem=function(sender,itemName)
		self:CharAddItem(itemName);
		self:AllAddItem(itemName);
	end
	self.CharListIndexOf=function(sender,itemName)
		local found=false;
		local index=1;
		while index<=#self.CharItemArray and not found do
			if self.CharItemArray[index][1]==itemName then
				found=true;
			else
				index=index+1;
			end
		end
		if not found then index=0 end;
		return(index);
	end
	self.AllListIndexOf=function(sender,itemName)
		local found=false;
		local index=1;
		while index<=#self.AllItemArray and not found do
			if self.AllItemArray[index][1]==itemName then
				found=true;
			else
				index=index+1;
			end
		end
		if not found then index=0 end;
		return(index);
	end
	self.CharAddItem=function(sender,itemName)
		if self:CharListIndexOf(itemName)==0 then
			-- if the character doesn't actually have any of the item we need to get the item info from GetAllItemInfo, then set the qty to 0
			local tmpNode=inventoryWindow:GetCharItemInfo(itemName);
			if tmpNode==nil then
				tmpNode=inventoryWindow:GetAllItemInfo(itemName);
				tmpNode[2]=0;
				tmpNode[3]={};
			end
			tmpNode[11]=-1; -- low threshold;
			tmpNode[12]=-1; -- low threshold;
			if tmpNode[2]>self.DefaultCharLowThreshold then
				tmpNode[13]=0;
			elseif tmpNode[2]>self.DefaultCharCriticalThreshold then
				tmpNode[13]=1;
			else
				tmpNode[13]=2;
			end
--*** we need to copy the values not assign a pointer...
			self.CharItemArray[#self.CharItemArray+1]=tmpNode;
		end
		if self:IsVisible() then
			self:RefreshCharList();
		end
	end
	self.AllAddItem=function(sender,itemName)
		if self:AllListIndexOf(itemName)==0 then
			local tmpNode=inventoryWindow:GetAllItemInfo(itemName);
			tmpNode[11]=-1;
			tmpNode[12]=-1;
			if tmpNode[2]>self.DefaultAllLowThreshold then
				tmpNode[13]=0;
			elseif tmpNode[2]>self.DefaultAllCriticalThreshold then
				tmpNode[13]=1;
			else
				tmpNode[13]=2;
			end
--*** we need to copy the values not assign a pointer...
			self.AllItemArray[#self.AllItemArray+1]=tmpNode;
		end
		if self:IsVisible() then
			self:RefreshAllList();
		end
	end
	self.RemoveItem=function(sender,itemName)
		self:CharRemoveItem(itemName);
		self:AllRemoveItem(itemName);
	end
	self.CharRemoveItem=function(sender,itemName)
		local index=self:CharListIndexOf(itemName);
		if index>0 then
			table.remove(self.CharItemArray,index);
		end
		if self:IsVisible() then
			self:RefreshCharList();
		end
	end
	self.AllRemoveItem=function(sender,itemName)
		local index=self:AllListIndexOf(itemName);
		if index>0 then
			table.remove(self.AllItemArray,index);
		end
		if self:IsVisible() then
			self:RefreshAllList();
		end
	end
	self.RefreshCharList=function()
		-- sort list
		table.sort(self.CharItemArray,function(arg1,arg2) if arg1[13]>arg2[13] then return(true) elseif arg1[13]==arg2[13] and arg1[1]<arg2[1] then return(true) end end);
		-- clear the display
		while self.CharItemList:GetItemCount()>0 do
			-- remove the event handler so garbage collection can collect the controls...
			self.CharItemList:GetItem(1).Label.MouseClick=nil;
			self.CharItemList:RemoveItemAt(1);
		end
		if #self.CharItemArray>0 then
			local index;
			for index=1,#self.CharItemArray do
				tmpItem=Turbine.UI.Label();
				tmpItem:SetParent(self.CharItemList);
				tmpItem:SetPosition(0,0);
				tmpItem:SetSize(self.CharItemList:GetWidth(),20);
				tmpItem.Label=Turbine.UI.Label();
				tmpItem.Label:SetParent(tmpItem);
				tmpItem.Label:SetFontStyle(Turbine.UI.FontStyle.Outline);
				tmpItem.Label:SetOutlineColor(Turbine.UI.Color(0,0,0));

				if self.CharItemArray[index][13]==0 then
					tmpItem.Label:SetBackColor(Turbine.UI.Color(0,0,0));
				elseif self.CharItemArray[index][13]==1 then
					tmpItem.Label:SetBackColor(Turbine.UI.Color(.2,.2,0));
				else
					tmpItem.Label:SetBackColor(Turbine.UI.Color(.2,0,0));
				end
				if self.ShowIconsInList then
					tmpItem.ItemIconBack=Turbine.UI.Label();
					tmpItem.ItemIconBack:SetParent(tmpItem);
					tmpItem.ItemIconBack:SetSize(32,32);
					tmpItem.ItemIconBack:SetPosition(0,0);
					tmpItem.ItemIconBack:SetBackground(self.CharItemArray[index][4]);
					tmpItem.ItemIconBack:SetOpacity(1);
					tmpItem.ItemIcon=Turbine.UI.Label();
					tmpItem.ItemIcon:SetParent(tmpItem);
					tmpItem.ItemIcon:SetSize(32,32);
					tmpItem.ItemIcon:SetPosition(0,0);
					tmpItem.ItemIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
					tmpItem.ItemIcon:SetBackground(self.CharItemArray[index][5]);
					tmpItem.ItemIcon:SetZOrder(tmpItem.ItemIconBack:GetZOrder()+1);
					tmpItem.Label:SetPosition(33,0);
					tmpItem.Label:SetSize(self.CharItemList:GetWidth(),32);
					tmpItem:SetSize(self.CharItemList:GetWidth(),32);
					if self.CharItemArray[index][2]~=nil and self.CharItemArray[index][2]>1 then
						tmpItem.QtyText=Turbine.UI.Label();
						tmpItem.QtyText:SetParent(tmpItem);
						tmpItem.QtyText:SetSize(34,27);
						tmpItem.QtyText:SetPosition(-2,0);
						tmpItem.QtyText:SetFontStyle(Turbine.UI.FontStyle.Outline);
						tmpItem.QtyText:SetOutlineColor(Turbine.UI.Color(0,0,0));
						tmpItem.QtyText:SetForeColor(Turbine.UI.Color(1,1,1));
						tmpItem.QtyText:SetTextAlignment( Turbine.UI.ContentAlignment.BottomRight );
						if self.CharItemArray[index][2]<10000 then
							tmpItem.QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
						else
							tmpItem.QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana10);
						end
						tmpItem.QtyText:SetText(self.CharItemArray[index][2].." ");
						tmpItem.QtyText:SetZOrder(tmpItem.ItemIcon:GetZOrder()+1);
					end
				else
					tmpItem.Label:SetPosition(0,0);
					tmpItem.Label:SetSize(self.CharItemList:GetWidth(),20);
				end
				if self.CharItemArray[index][10]==Turbine.Gameplay.ItemQuality.Common then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(.95,.95,.95));
				elseif self.CharItemArray[index][10]==Turbine.Gameplay.ItemQuality.Incomparable then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(0,.8,.75));
				elseif self.CharItemArray[index][10]==Turbine.Gameplay.ItemQuality.Legendary then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(.8,.5,.2));
				elseif self.CharItemArray[index][10]==Turbine.Gameplay.ItemQuality.Rare then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(.75,0,.75));
				elseif self.CharItemArray[index][10]==Turbine.Gameplay.ItemQuality.Uncommon then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(.75,.85,.1));
				end
				tmpItem.Label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
				tmpItem.Label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
				tmpItem.Label:SetText(self.CharItemArray[index][1].." "..self.CharItemArray[index][2]);
				tmpItem.Label.MouseClick=function(sender,args)
					if args.Button==2 then
						self.TrackMenu:GetItems():Get(1).Click=function()
							self:RemoveItem(self.CharItemArray[index][1]);
						end
						self.TrackMenu:GetItems():Get(2).Click=function()
							customThresholdWindow:SetItem(self.CharItemArray[index][1],index,false,self.CharItemArray[index][11],self.CharItemArray[index][12]);
							customThresholdWindow:SetZOrder(self:GetZOrder()+1);
							customThresholdWindow:SetVisible(true);
						end
						self.TrackMenu:ShowMenu()
					end
				end

				self.CharItemList:AddItem(tmpItem);
			end
			if self.ShowIconsInList then
				if self.CharItemList:GetItemCount()*32>self.CharItemList:GetHeight() then
					self.CharItemList.VScrollBar:SetVisible(true);
				end
			else
				if self.CharItemList:GetItemCount()*20>self.CharItemList:GetHeight() then
					self.CharItemList.VScrollBar:SetVisible(true);
				end
			end
		end
	end
	self.RefreshAllList=function()
		local index;
		table.sort(self.AllItemArray,function(arg1,arg2) if arg1[13]>arg2[13] then return(true) elseif arg1[13]==arg2[13] and arg1[1]<arg2[1] then return(true) end end);
		while self.AllItemList:GetItemCount()>0 do
			self.AllItemList:GetItem(1).Label.MouseEnter=nil;
			self.AllItemList:GetItem(1).Label.Update=nil;
			self.AllItemList:GetItem(1).Label.MouseLeave=nil;
			self.AllItemList:GetItem(1).Label.MouseClick=nil;
			self.AllItemList:RemoveItemAt(1);
		end
		if #self.AllItemArray>0 then
			for index=1,#self.AllItemArray do
				local tmpItem=Turbine.UI.Label();
				tmpItem:SetParent(self.AllItemList);
				tmpItem:SetPosition(0,0);
				tmpItem:SetSize(self.AllItemList:GetWidth(),20);
				tmpItem.Label=Turbine.UI.Label();
				tmpItem.Label:SetParent(tmpItem);
				tmpItem.Label:SetFontStyle(Turbine.UI.FontStyle.Outline);
				tmpItem.Label:SetOutlineColor(Turbine.UI.Color(0,0,0));
				if self.AllItemArray[index][13]==0 then
					tmpItem.Label:SetBackColor(Turbine.UI.Color(0,0,0));
				elseif self.AllItemArray[index][13]==1 then
					tmpItem.Label:SetBackColor(Turbine.UI.Color(.2,.2,0));
				else
					tmpItem.Label:SetBackColor(Turbine.UI.Color(.2,0,0));
				end
				if self.ShowIconsInList then
					tmpItem.ItemIconBack=Turbine.UI.Label();
					tmpItem.ItemIconBack:SetParent(tmpItem);
					tmpItem.ItemIconBack:SetSize(32,32);
					tmpItem.ItemIconBack:SetPosition(0,0);
					tmpItem.ItemIconBack:SetBackground(self.AllItemArray[index][4]);
					tmpItem.ItemIconBack:SetOpacity(1);
					tmpItem.ItemIcon=Turbine.UI.Label();
					tmpItem.ItemIcon:SetParent(tmpItem);
					tmpItem.ItemIcon:SetSize(32,32);
					tmpItem.ItemIcon:SetPosition(0,0);
					tmpItem.ItemIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
					tmpItem.ItemIcon:SetBackground(self.AllItemArray[index][5]);
					tmpItem.ItemIcon:SetZOrder(tmpItem.ItemIconBack:GetZOrder()+1);
					tmpItem.Label:SetPosition(33,0);
					tmpItem.Label:SetSize(self.AllItemList:GetWidth(),32);
					tmpItem:SetSize(self.AllItemList:GetWidth(),32);
					if self.AllItemArray[index][2]~=nil and self.AllItemArray[index][2]>1 then
						tmpItem.QtyText=Turbine.UI.Label();
						tmpItem.QtyText:SetParent(tmpItem);
						tmpItem.QtyText:SetSize(34,27);
						tmpItem.QtyText:SetPosition(-2,0);
						tmpItem.QtyText:SetFontStyle(Turbine.UI.FontStyle.Outline);
						tmpItem.QtyText:SetOutlineColor(Turbine.UI.Color(0,0,0));
						tmpItem.QtyText:SetForeColor(Turbine.UI.Color(1,1,1));
						tmpItem.QtyText:SetTextAlignment( Turbine.UI.ContentAlignment.BottomRight );
						if self.AllItemArray[index][2]<10000 then
							tmpItem.QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
						else
							tmpItem.QtyText:SetFont(Turbine.UI.Lotro.Font.Verdana10);
						end
						tmpItem.QtyText:SetText(self.AllItemArray[index][2].." ");
						tmpItem.QtyText:SetZOrder(tmpItem.ItemIcon:GetZOrder()+1);
					end
				else
					tmpItem.Label:SetPosition(0,0);
					tmpItem.Label:SetSize(self.AllItemList:GetWidth(),20);
				end
				if self.AllItemArray[index][10]==Turbine.Gameplay.ItemQuality.Common then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(.95,.95,.95));
				elseif self.AllItemArray[index][10]==Turbine.Gameplay.ItemQuality.Incomparable then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(0,.8,.75));
				elseif self.AllItemArray[index][10]==Turbine.Gameplay.ItemQuality.Legendary then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(.8,.5,.2));
				elseif self.AllItemArray[index][10]==Turbine.Gameplay.ItemQuality.Rare then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(.75,0,.75));
				elseif self.AllItemArray[index][10]==Turbine.Gameplay.ItemQuality.Uncommon then
					tmpItem.Label:SetForeColor(Turbine.UI.Color(.75,.85,.1));
				end
				tmpItem.Label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
				tmpItem.Label:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft);
				tmpItem.Label:SetText(self.AllItemArray[index][1].." "..self.AllItemArray[index][2]);
				tmpItem.Label.MouseEnter=function(sender,args)
					self.ItemHoverTimer=Turbine.Engine.GetGameTime()+.7;
					tmpItem.Label:SetWantsUpdates(true)
				end
				tmpItem.Label.Update=function(sender,args)
					if Turbine.Engine.GetGameTime()>self.ItemHoverTimer then
						tmpItem.Label:SetWantsUpdates(false);
						local tmpMenu=self.QuantityMenu:GetItems()
						local tmpMenuItem=nil;
						local menuIndex=1;
						local menuItem=nil;
						tmpMenu:Clear();
						for menuIndex=1,#self.AllItemArray[index][3] do
							tmpMenuItem=Turbine.UI.MenuItem();
							tmpMenuItem:SetText(characterListArray[self.AllItemArray[index][3][menuIndex][1]][1].." "..self.AllItemArray[index][3][menuIndex][2]);
							tmpMenuItem:SetEnabled(false);
							tmpMenu:Add(tmpMenuItem);
						end
						self.QuantityMenu:ShowMenu();
					end
				end
				tmpItem.Label.MouseLeave=function(sender,args)
					tmpItem.Label:SetWantsUpdates(false)
				end

				tmpItem.Label.MouseClick=function(sender,args)
					if args.Button==2 then
						self.TrackMenu:GetItems():Get(1).Click=function()
							self:RemoveItem(self.AllItemArray[index][1]);
						end
						self.TrackMenu:GetItems():Get(2).Click=function()
							customThresholdWindow:SetItem(self.AllItemArray[index][1],index,true,self.AllItemArray[index][11],self.AllItemArray[index][12]);
							customThresholdWindow:SetZOrder(self:GetZOrder()+1);
							customThresholdWindow:SetVisible(true);
						end
						self.TrackMenu:ShowMenu()
					else
						local tmpMenu=self.QuantityMenu:GetItems()
						local tmpMenuItem=nil;
						local menuIndex=1;
						local menuItem=nil;
						tmpMenu:Clear();
						for menuIndex=1,#self.AllItemArray[index][3] do
							tmpMenuItem=Turbine.UI.MenuItem();
							tmpMenuItem:SetText(characterListArray[self.AllItemArray[index][3][menuIndex][1]][1].." "..self.AllItemArray[index][3][menuIndex][2]);
							tmpMenuItem:SetEnabled(false);
							tmpMenu:Add(tmpMenuItem);
						end
						self.QuantityMenu:ShowMenu();
					end
				end
				self.AllItemList:AddItem(tmpItem);
			end
			if self.ShowIconsInList then
				if self.AllItemList:GetItemCount()*32>self.AllItemList:GetHeight() then
					self.AllItemList.VScrollBar:SetVisible(true);
				end
			else
				if self.AllItemList:GetItemCount()*20>self.AllItemList:GetHeight() then
					self.AllItemList.VScrollBar:SetVisible(true);
				end
			end
		end
	end
	self.VisibleChanged=function(sender,args)
		if self:IsVisible() then
			self:RefreshCharList();
			self:RefreshAllList();
		end
	end
	self.SetShowIconsInList=function(sender,value)
		self.ShowIconsInList=value;
		if self:IsVisible() then
			self:RefreshCharList();
			self:RefreshAllList();
		end
	end
	self.RefreshCharStatus=function()
		local index;
		for index=1,#self.CharItemArray do
			self.CharItemArray[index][13]=0
			if self.CharItemArray[index][11]==-1 then
				if self.CharItemArray[index][2]<=self.DefaultCharLowThreshold then
					self.CharItemArray[index][13]=1
				end
			else
				if self.CharItemArray[index][2]<=self.CharItemArray[index][11] then
					self.CharItemArray[index][13]=1
				end
			end
			if self.CharItemArray[index][12]==-1 then
				if self.CharItemArray[index][2]<=self.DefaultCharCriticalThreshold then
					self.CharItemArray[index][13]=2
				end
			else
				if self.CharItemArray[index][2]<=self.CharItemArray[index][12] then
					self.CharItemArray[index][13]=2
				end
			end
		end
	end
	self.RefreshAllStatus=function()
		local index;
		for index=1,#self.AllItemArray do
			self.AllItemArray[index][13]=0
			if self.AllItemArray[index][11]==-1 then
				if self.AllItemArray[index][2]<=self.DefaultAllLowThreshold then
					self.AllItemArray[index][13]=1
				end
			else
				if self.AllItemArray[index][2]<=self.AllItemArray[index][11] then
					self.AllItemArray[index][13]=1
				end
			end
			if self.AllItemArray[index][12]==-1 then
				if self.AllItemArray[index][2]<=self.DefaultAllCriticalThreshold then
					self.AllItemArray[index][13]=2
				end
			else
				if self.AllItemArray[index][2]<=self.AllItemArray[index][12] then
					self.AllItemArray[index][13]=2
				end
			end
		end
	end
	self.GetShowIconsInList=function()
		return(self.ShowIconsInList);
	end
	self.SetDefaultCharLowThreshold=function(sender,value)
		self.DefaultCharLowThreshold=tonumber(value);
	end
	self.GetDefaultCharLowThreshold=function()
		return(self.DefaultCharLowThreshold);
	end
	self.SetDefaultCharCriticalThreshold=function(sender,value)
		self.DefaultCharCriticalThreshold=tonumber(value);
	end
	self.GetDefaultCharCriticalThreshold=function()
		return(self.DefaultCharCriticalThreshold);
	end
	self.SetDefaultAllLowThreshold=function(sender,value)
		self.DefaultAllLowThreshold=tonumber(value);
	end
	self.GetDefaultAllLowThreshold=function()
		return(self.DefaultAllLowThreshold);
	end
	self.SetDefaultAllCriticalThreshold=function(sender,value)
		self.DefaultAllCriticalThreshold=tonumber(value);
	end
	self.GetDefaultAllCriticalThreshold=function()
		return(self.DefaultAllCriticalThreshold);
	end

	self.UpdateQuantity=function(sender,strItemName)
		-- the actual update has to be done asynchronously since performing it in the middle of a stack merge operation gives incorrect quantities
		-- and the ItemRemoved event doesn't trigger from the merge (otherwise we could forget this nonsense and just process off the ItemRemoved event)
		self.NeedsQtyUpdate=true;
		self.ItemChanged=strItemName;
		self:SetWantsUpdates(true);
	end
	self.Update=function(sender,args)
		if self.NeedsQtyUpdate then
			-- we got an UpdateQuantity event and need to complete processing it
			self:SetWantsUpdates(false);
			self.NeedsQtyUpdate=false;
			self:AsyncUpdateQuantity(self.ItemChanged)
		end
	end
	self.AsyncUpdateQuantity=function(sender,strItemName)
		-- due to the bug in merging stacks and the bug with non-stackables having a quantity of 0, we have to scan the entire backpack and get a new total for this item :(
		local newQuantity=0;
		local backpack=localPlayer:GetBackpack();
		local itemIndex;
		local tmpItem;
		for itemIndex=1,backpack:GetSize() do
			tmpItem=backpack:GetItem(itemIndex);
			if tmpItem~=nil and tmpItem:GetName()==strItemName then
				if tmpItem:GetQuantity()==0 then
					-- handle the odd situation with non-stackables having quantity=0
					newQuantity=newQuantity+1;
				else
					newQuantity=newQuantity+tmpItem:GetQuantity();
				end
			end
		end

		-- this can only be valid for items in the user's own bags but has to affect both Char and All
		local alert=0;
		local index=self:CharListIndexOf(strItemName);
		local status=0;
		if index>0 then
			local delta=newQuantity-tonumber(self.CharItemArray[index][2]);
			self.CharItemArray[index][2]=newQuantity;
			if self.CharItemArray[index][12]==-1 then
				if newQuantity<=self.DefaultCharCriticalThreshold then
					status=2;
				end
			else
				if newQuantity<=self.CharItemArray[index][12] then
					status=2;
				end
			end
			if status==0 then
				if self.CharItemArray[index][11]==-1 then
					if newQuantity<=self.DefaultCharLowThreshold then
						status=1;
					end
				else
					if newQuantity<=self.CharItemArray[index][11] then
						status=1;
					end
				end
			end
			self.CharItemArray[index][13]=status;
			if delta<0 then
				if status==2 then
					Turbine.Shell.WriteLine("ITEM TRACKING ALERT:"..self.CharItemArray[index][1].." Character Qty="..self.CharItemArray[index][2]);
				end
				if status==1 then
					Turbine.Shell.WriteLine("Item Tracking Warning:"..self.CharItemArray[index][1].." Character Qty="..self.CharItemArray[index][2]);
				end
			end
			if delta<0 then alert=status end;
			self:RefreshCharList();
		end
		index=self:AllListIndexOf(strItemName);
		if index>0 then
			-- need to find the user's contribution to quantity
			local charIndex=1;
			local oldQuantity=0;
			local done=false;
			while charIndex<=#self.AllItemArray[index][3] and not done do

				if characterListArray[self.AllItemArray[index][3][charIndex][1]][1]==currentCharacterName then
					oldQuantity=tonumber(self.AllItemArray[index][3][charIndex][2]);
					self.AllItemArray[index][3][charIndex][2]=newQuantity;
					if newQuantity==0 then
						-- need to delete the sub-entry for this character since it no longer contributes. a new entry will get created if it starts contributing again.
						table.remove(self.AllItemArray[index][3],charIndex);
					end
					done=true;
				else
					charIndex=charIndex+1;
				end
			end
			if newQuantity>0 and not done then
				-- need to create a new sub-entry for this character/qty...
				self.AllItemArray[index][3][#self.AllItemArray[index][3]+1]={currentCharIndex,newQuantity};
			end
			local delta=newQuantity-oldQuantity;
			self.AllItemArray[index][2]=self.AllItemArray[index][2]+delta;
			if self.AllItemArray[index][12]==-1 then
				if self.AllItemArray[index][2]<=self.DefaultAllCriticalThreshold then
					status=2;
				end
			else
				if self.AllItemArray[index][2]<=self.AllItemArray[index][12] then
					status=2;
				end
			end
			if status==0 then
				if self.AllItemArray[index][11]==-1 then
					if self.AllItemArray[index][2]<=self.DefaultAllLowThreshold then
						status=1;
					end
				else
					if self.AllItemArray[index][2]<=self.AllItemArray[index][11] then
						status=1;
					end
				end
			end
			self.AllItemArray[index][13]=status;
			if delta<0 then
				if status==2 then
					Turbine.Shell.WriteLine("ITEM TRACKING ALERT:"..self.AllItemArray[index][1].." Total Qty="..self.AllItemArray[index][2]);
				end
				if status==1 then
					Turbine.Shell.WriteLine("Item Tracking Warning:"..self.AllItemArray[index][1].." Total Qty="..self.AllItemArray[index][2]);
				end
			end
			if delta<0 and status>alert then alert=status end;
			self:RefreshAllList();
		end
		if alert==1 then minWindow:FlashYellow() end;
		if alert==2 then minWindow:FlashRed() end;
	end

	self.SaveData=function()
		-- save the Char data as character scope
		PatchDataSave( Turbine.DataScope.Character, "AltInventoryTrackData", self.CharItemArray);
		-- save the All data as server scope
		PatchDataSave( Turbine.DataScope.Server, "AltInventoryTrackData", self.AllItemArray);
	end
	self.LoadData=function()
		self.CharItemArray=PatchDataLoad(Turbine.DataScope.Character, "AltInventoryTrackData");
		if self.CharItemArray==nil then
			self.CharItemArray={}
		end
		self.AllItemArray=PatchDataLoad(Turbine.DataScope.Server, "AltInventoryTrackData");
		if self.AllItemArray==nil then
			self.AllItemArray={}
		end
	end
	self.SetCustomThresholds=function(sender,lowThreshold, criticalThreshold, index, applyToAll)
		if index~=nil and applyToAll~=nil then
			index=tonumber(index);
			if applyToAll==true then
				if index>0 and index<=#self.AllItemArray then
					self.AllItemArray[index][11]=lowThreshold;
					self.AllItemArray[index][12]=criticalThreshold;
				end
			else
				if index>0 and index<=#self.CharItemArray then
					self.CharItemArray[index][11]=lowThreshold;
					self.CharItemArray[index][12]=criticalThreshold;
				end
			end
		end
	end
	self.SetTrimColor=function()
	end
	self.SetBackColor=function()
	end
	self.SetFontColor=function()
	end
	self.SetLanguage=function()
		self:SetText(Resource[language][35]);
		self.CharTab:SetText(Resource[language][36]);
		self.AllTab:SetText(Resource[language][29]);
		self.TrackMenu:GetItems():Get(1):SetText(Resource[language][46]);
		self.TrackMenu:GetItems():Get(2):SetText(Resource[language][37]);
	end
end

-- tables AllItemArray and CharItemArray have the following structure
-- -- [1] item name
-- -- [2] item quantity
-- -- [3] table of individual quantities (only valid for AllItemArray
-- -- [3][x][1] Character Index - index into characterListArray DO NOT USER - THIS VALUE IS SUBJECT TO CORRUPTION WHEN CHARACTERS ARE ADDED/REMOVED
-- -- [3][x][2] Quantity
-- -- [3][x][3] Character Name - this replaces the "Character Index" since it will only become invalid if a character is renamed, and in THAT case, the old version of the character has to manually removed anyway...
-- -- [4] icon background resource id
-- -- [5] icon image resource id
-- -- [6] icon quality resource id (not currently used)
-- -- [7] icon shadow resource id (not currently used)
-- -- [8] icon underlay image resource id (not currently used)
-- -- [9] category
-- -- [10] quality
-- -- [11] item low threshold (-1=usedefault)
-- -- [12] item critical threshold (-1=usedefault)
-- -- [13] item status (0 [2]>=[11], 1 [11]>[2]>=[12], 2 [12]>=[2])
