
-- to do:
-- set selections back to SlottedTraits when hitting "Cancel"
-- set the SlottedTraits for the character to the ones selected when hitting "Save" and then load panel data
-- for load panel data, fill in the slots with the values from SlottedTraits

-- SlottedTraits format: [characterName][index]={type,cat,id,subcat (optional, currently only valid for class traits), tier (optional, currently only valid for virtues/corruptions)}


--one tab per trait type
-- allow filling traits from scrollable list of traits -- probably need a separate pop-up window to list the available traits
-- would be nice to have the examine window for traits
-- the resource images would be nice but there's LOTS still undiscovered though :(
-- really need a data table of traits kind of like the recipe system, just not quite as large

-- Traits table format: allegiance, type (virtue/corruption, legendary, class, racial), name, resourceID, examine ID

import "GaranStuff.AltInventory.Traits";

euroFormat=(tonumber("1,000")==1); -- redundant but harmless

function LoadData()
	-- load saved settings
	SlottedTraits=PatchDataLoad( Turbine.DataScope.Server, "AltInventory_SlottedTraits");
	if SlottedTraits==nil then
		SlottedTraits={};
	end
end
LoadData()

TraitsPanel=class(Turbine.UI.Control)
function TraitsPanel:Constructor()
	Turbine.UI.Control.Constructor(self)
	self:SetMouseVisible(false);
	self:SetBackColor(backColor);
	self:SetSize(200,200);
	self.characterIndex=1;
	local charIndex;
	for charIndex=1,#characterListArray do
		if characterListArray[charIndex][1]==currentCharacterName then
			self.characterIndex=charIndex;
			break;
		end
	end
	self.characterName=currentCharacterName;
	self.LoadingSelections=false; -- flag used to disable the CheckedChanged event handler when loading character data
	self.GetSubCat=function(category)
		local value=1;
		local tmpVal;
		-- returns the appropriate class/race subcategory
		if self.Alignment==1 then
			if category==1 then
				-- virtues are all subcat 1
				value=1;
			elseif category==2 then
				--race
				tmpVal=characterListArray[self.characterIndex][5];
				if tmpVal==Turbine.Gameplay.Race.Dwarf then
					value=1;
				elseif tmpVal==Turbine.Gameplay.Race.Elf then
					value=2;
				elseif tmpVal==Turbine.Gameplay.Race.Hobbit then
					value=3;
				elseif tmpVal==Turbine.Gameplay.Race.Man then
					value=4;
				end
			else
				-- class
				tmpVal=characterListArray[self.characterIndex][6];
				if tmpVal==Turbine.Gameplay.Class.Burglar then
					value=1;
				elseif tmpVal==Turbine.Gameplay.Class.Captain then
					value=2;
				elseif tmpVal==Turbine.Gameplay.Class.Champion then
					value=3;
				elseif tmpVal==Turbine.Gameplay.Class.Guardian then
					value=4;
				elseif tmpVal==Turbine.Gameplay.Class.Hunter then
					value=5;
				elseif tmpVal==Turbine.Gameplay.Class.LoreMaster then
					value=6;
				elseif tmpVal==Turbine.Gameplay.Class.Minstrel then
					value=7;
				elseif tmpVal==Turbine.Gameplay.Class.RuneKeeper then
					value=8;
				elseif tmpVal==Turbine.Gameplay.Class.Warden then
					value=9;
				end
				
			end
		else
			if category==1 then
				value=1;
			elseif category==2 then
				--race
				tmpVal=characterListArray[self.characterIndex][5];
				-- note, the race enumeration values are missing for creepside
				--Turbine.Gameplay.Race.Orc=7
				--Turbine.Gameplay.Race.Spider=12
				--Turbine.Gameplay.Race.Uruk=6
				--Turbine.Gameplay.Race.Warg=66
				if tmpVal==7 then
					value=1;
				elseif tmpVal==12 then
					value=2;
				elseif tmpVal==6 then
					value=3;
				elseif tmpVal==66 then
					value=4;
				end
			else
				-- class
				tmpVal=characterListArray[self.characterIndex][6];
				if tmpVal==Turbine.Gameplay.Class.BlackArrow then
					value=1;
				elseif tmpVal==Turbine.Gameplay.Class.Defiler then
					value=2;
				elseif tmpVal==Turbine.Gameplay.Class.Reaver then
					value=3;
				elseif tmpVal==Turbine.Gameplay.Class.Stalker then
					value=4;
				elseif tmpVal==Turbine.Gameplay.Class.WarLeader then
					value=5;
				elseif tmpVal==Turbine.Gameplay.Class.Weaver then
					value=6;
				end
			end
		end
		return value;
	end
-- create panel controls
	self.Tab={};

--	tabcolor={Turbine.UI.Color(.15,0,0),Turbine.UI.Color(0,.15,0),Turbine.UI.Color(0,0,.15),Turbine.UI.Color(.1,.1,0)}
	tabcolor={Turbine.UI.Color(0,0,.15),Turbine.UI.Color(.15,.1,0),Turbine.UI.Color(0,.15,0),Turbine.UI.Color(.15,0,0)}
	self.Slots={{5,5,7,3},{6,5,7,1}};

	self.Alignment=1;
	if localPlayer:GetAlignment()==Turbine.Gameplay.Alignment.MonsterPlayer then self.Alignment=2 end

	for tmpIndex=1,4 do
		self.Tab[tmpIndex]=Turbine.UI.Control();
		self.Tab[tmpIndex]:SetParent(self)
		self.Tab[tmpIndex]:SetZOrder(4-tmpIndex);
		self.Tab[tmpIndex]:SetMouseVisible(false);
		self.Tab[tmpIndex]:SetSize(self:GetSize());
		self.Tab[tmpIndex].Button=Turbine.UI.Label();
		self.Tab[tmpIndex].Button:SetParent(self.Tab[tmpIndex]);
		self.Tab[tmpIndex].Button:SetSize(100,20);
		self.Tab[tmpIndex].Button:SetPosition((tmpIndex-1)*100,5);
		self.Tab[tmpIndex].Button:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		self.Tab[tmpIndex].Button:SetText(Trait[self.Alignment][tmpIndex].Name);
		self.Tab[tmpIndex].Button:SetBackColor(tabcolor[tmpIndex]);
		self.Tab[tmpIndex].Button.Index=tmpIndex;
		self.Tab[tmpIndex].Button.MouseClick=function(sender,args)
			local tabIndex
			for tabIndex=1,4 do
				if tabIndex==sender.Index then
					self.Tab[tabIndex].Button:SetTop(0);
					self.Tab[tabIndex]:SetZOrder(2);
				else
					self.Tab[tabIndex].Button:SetTop(5);
					self.Tab[tabIndex]:SetZOrder(1);
				end
				self.Tab[tabIndex]:SetSize(self.Tab[tabIndex]:GetSize());
			end
		end
		self.Tab[tmpIndex].Panel=Turbine.UI.Control();
		self.Tab[tmpIndex].Panel:SetParent(self.Tab[tmpIndex]);
		self.Tab[tmpIndex].Panel:SetBackColor(tabcolor[tmpIndex]);
		self.Tab[tmpIndex].Panel:SetSize(self.Tab[tmpIndex]:GetWidth(),self.Tab[tmpIndex]:GetHeight()-20);
		self.Tab[tmpIndex].Panel:SetPosition(0,20);
		self.Tab[tmpIndex].SelectBtn=Turbine.UI.Lotro.Button();
		self.Tab[tmpIndex].SelectBtn:SetParent(self.Tab[tmpIndex].Panel);
		self.Tab[tmpIndex].SelectBtn:SetSize(100,22);
		self.Tab[tmpIndex].SelectBtn:SetPosition(35,3);
		self.Tab[tmpIndex].SelectBtn:SetText(Resource[language][339]);
		self.Tab[tmpIndex].SelectBtn.Index=tmpIndex;
		self.Tab[tmpIndex].SelectBtn.MouseClick=function(sender,args)			
			self:ShowTraitSelection(sender.Index);
		end
		self.Tab[tmpIndex].Equipped=Turbine.UI.ListBox();
		self.Tab[tmpIndex].Equipped:SetParent(self.Tab[tmpIndex].Panel);
		self.Tab[tmpIndex].Equipped:SetPosition(1,26);
		self.Tab[tmpIndex].Equipped:SetSize(self.Tab[tmpIndex].Panel:GetWidth()-14,self.Tab[tmpIndex].Panel:GetHeight()-27);
		self.Tab[tmpIndex].VScroll=Turbine.UI.Lotro.ScrollBar();
		self.Tab[tmpIndex].VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
		self.Tab[tmpIndex].VScroll:SetParent(self.Tab[tmpIndex].Panel);
		self.Tab[tmpIndex].VScroll:SetPosition(self.Tab[tmpIndex]:GetWidth()-13,26);
		self.Tab[tmpIndex].VScroll:SetSize(12,self.Tab[tmpIndex].Equipped:GetHeight());
		self.Tab[tmpIndex].Equipped:SetVerticalScrollBar(self.Tab[tmpIndex].VScroll);
	end

	self.Tab[1].Button:SetTop(0);
	self.TraitSelection={};
	for tmpIndex=1,4 do
		self.TraitSelection[tmpIndex]=Turbine.UI.Control();
		self.TraitSelection[tmpIndex]:SetParent(self);
		self.TraitSelection[tmpIndex]:SetVisible(false);
		self.TraitSelection[tmpIndex]:SetBackColor(tabcolor[tmpIndex]);
		self.TraitSelection[tmpIndex]:SetZOrder(5);
		self.TraitSelection[tmpIndex]:SetSize(self:GetSize());
		self.TraitSelection[tmpIndex].OKBtn=Turbine.UI.Lotro.Button();
		self.TraitSelection[tmpIndex].OKBtn:SetParent(self.TraitSelection[tmpIndex]);
		self.TraitSelection[tmpIndex].OKBtn:SetSize(90,22);
		self.TraitSelection[tmpIndex].OKBtn:SetText(Resource[language][19]);
		self.TraitSelection[tmpIndex].OKBtn.Index=tmpIndex;
		self.TraitSelection[tmpIndex].OKBtn:SetPosition(1,1);
		self.TraitSelection[tmpIndex].OKBtn.MouseClick=function(sender,args)
			-- save the selected entries
			-- SlottedTraits format: [characterName][index]={type,cat,id,subcat (optional), maxTier}
			local type=sender.Index;
			local cat=self.GetSubCat(type);
			if SlottedTraits[self.characterName]==nil then SlottedTraits[self.characterName]={} end

			-- clear out any old traits matching this type since we define them from scratch
			local tmpIndex=1;
			while tmpIndex<=#SlottedTraits[self.characterName] do
				if SlottedTraits[self.characterName][tmpIndex]~=nil and SlottedTraits[self.characterName][tmpIndex][1]==type then
					table.remove(SlottedTraits[self.characterName],tmpIndex);
				else
					tmpIndex=tmpIndex+1;
				end
			end

			-- now add back in any selected traits for this type
			local tmpIndex;
			for tmpIndex=1,self.TraitSelection[type].TraitList:GetItemCount() do
				if self.TraitSelection[type].TraitList:GetItem(tmpIndex).Checked~=nil then
					if self.TraitSelection[type].TraitList:GetItem(tmpIndex).Checked:IsChecked() then
						local newIndex=#SlottedTraits[self.characterName]+1;
						SlottedTraits[self.characterName][newIndex]={type,cat,self.TraitSelection[type].TraitList:GetItem(tmpIndex).TraitID,self.TraitSelection[type].TraitList:GetItem(tmpIndex).SubClass,self.TraitSelection[type].TraitList:GetItem(tmpIndex).CurrentTier};
					end
				end
			end
			self:LoadPanelData(self.characterName);
			self.TraitSelection[sender.Index]:SetVisible(false);
		end

		self.TraitSelection[tmpIndex].Caption=Turbine.UI.Label();
		self.TraitSelection[tmpIndex].Caption:SetParent(self.TraitSelection[tmpIndex]);
		self.TraitSelection[tmpIndex].Caption:SetSize(self.TraitSelection[tmpIndex]:GetWidth()-184,22);
		self.TraitSelection[tmpIndex].Caption:SetPosition(82,1);
		self.TraitSelection[tmpIndex].Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		self.TraitSelection[tmpIndex].NumberSelected=0;
		self.TraitSelection[tmpIndex].Caption:SetText(Trait[self.Alignment][tmpIndex].Name.." "..Resource[language][339].." ("..tostring(self.TraitSelection[tmpIndex].NumberSelected).."/"..tostring(self.Slots[self.Alignment][tmpIndex])..")"); -- number selected/number slots
		self.TraitSelection[tmpIndex].CancelBtn=Turbine.UI.Lotro.Button();
		self.TraitSelection[tmpIndex].CancelBtn:SetParent(self.TraitSelection[tmpIndex]);
		self.TraitSelection[tmpIndex].CancelBtn:SetSize(90,22);
		self.TraitSelection[tmpIndex].CancelBtn:SetText(Resource[language][20]);
		self.TraitSelection[tmpIndex].CancelBtn:SetPosition(self.TraitSelection[tmpIndex]:GetWidth()-91,1);
		self.TraitSelection[tmpIndex].CancelBtn.Index=tmpIndex;
		self.TraitSelection[tmpIndex].CancelBtn.MouseClick=function(sender,args)
-- really need to reset the list to the current list of selected values
			self.TraitSelection[sender.Index]:SetVisible(false);
		end

		self.TraitSelection[tmpIndex].TraitList=Turbine.UI.ListBox();
		self.TraitSelection[tmpIndex].TraitList:SetParent(self.TraitSelection[tmpIndex]);
		self.TraitSelection[tmpIndex].TraitList:SetSize(self.TraitSelection[tmpIndex]:GetWidth()-14,self.TraitSelection[tmpIndex]:GetHeight()-25)
		self.TraitSelection[tmpIndex].TraitList:SetPosition(1,24);
		self.TraitSelection[tmpIndex].VScroll=Turbine.UI.Lotro.ScrollBar();
		self.TraitSelection[tmpIndex].VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
		self.TraitSelection[tmpIndex].VScroll:SetParent(self.TraitSelection[tmpIndex]);
		self.TraitSelection[tmpIndex].VScroll:SetPosition(self.TraitSelection[tmpIndex]:GetWidth()-13,24);
		self.TraitSelection[tmpIndex].VScroll:SetSize(12,self.TraitSelection[tmpIndex]:GetHeight()-22);
		self.TraitSelection[tmpIndex].TraitList:SetVerticalScrollBar(self.TraitSelection[tmpIndex].VScroll);
	end

	self.ShowTraitSelection=function(sender,type)
		self.TraitSelection[type].TraitList:ClearItems();

		-- populate the list
		local traitIndex;
		local subCat=self.GetSubCat(type);
Turbine.Shell.WriteLine("alignment:"..tostring(self.Alignment).." type:"..tostring(type).." subCat:"..tostring(subCat))
		for traitIndex=1,#Trait[self.Alignment][type][subCat] do
			if Trait[self.Alignment][type][subCat].SubClassed==nil then
				local tmpRow=Turbine.UI.Control()
				tmpRow:SetParent(self.TraitSelection[type].TraitList)
				tmpRow:SetSize(self.TraitSelection[type].TraitList:GetWidth(),33)
				tmpRow.TraitID=Trait[self.Alignment][type][subCat][traitIndex][1];
				tmpRow.SubClass=nil;
				tmpRow.Checked=Turbine.UI.Lotro.CheckBox();
				tmpRow.Checked:SetParent(tmpRow);
				tmpRow.Checked:SetSize(self.TraitSelection[type].TraitList:GetWidth(),32);
				tmpRow.Checked:SetPosition(0,0);
				tmpRow.Checked.TabIndex=type;
				tmpRow.Checked:SetChecked(false); -- a tad redundant but doesn't hurt
				tmpRow.Checked.CheckedChanged=function(sender)
					if not self.LoadingSelections then
						if sender:IsChecked() then
							self.TraitSelection[sender.TabIndex].NumberSelected=self.TraitSelection[sender.TabIndex].NumberSelected+1;
							if self.TraitSelection[sender.TabIndex].NumberSelected>self.Slots[self.Alignment][sender.TabIndex] then
								sender:SetChecked(false);
							else
								self.TraitSelection[sender.TabIndex].Caption:SetText(Trait[self.Alignment][sender.TabIndex].Name.." "..Resource[language][339].." ("..tostring(self.TraitSelection[sender.TabIndex].NumberSelected).."/"..tostring(self.Slots[self.Alignment][sender.TabIndex])..")"); -- number selected/number slots
							end
						else
							self.TraitSelection[sender.TabIndex].NumberSelected=self.TraitSelection[sender.TabIndex].NumberSelected-1;
							self.TraitSelection[sender.TabIndex].Caption:SetText(Trait[self.Alignment][sender.TabIndex].Name.." "..Resource[language][339].." ("..tostring(self.TraitSelection[sender.TabIndex].NumberSelected).."/"..tostring(self.Slots[self.Alignment][sender.TabIndex])..")"); -- number selected/number slots
						end
					end
				end
				tmpRow.Icon=Turbine.UI.Control();
				tmpRow.Icon:SetParent(tmpRow);
				tmpRow.Icon:SetSize(32,32);
				tmpRow.Icon:SetPosition(17,0);
				if Trait[self.Alignment][type][subCat][traitIndex][3]~=nil and Trait[self.Alignment][type][subCat][traitIndex][3]>0 then
					tmpRow.Icon:SetBackground(Trait[self.Alignment][type][subCat][traitIndex][3]);
				else
					tmpRow.Icon:SetBackground(0x410d461e); -- blank trait background
				end
				tmpRow.Icon:SetMouseVisible(false);
				tmpRow.Caption=Turbine.UI.Label();
				tmpRow.Caption:SetParent(tmpRow);
				tmpRow.Caption:SetSize(self.TraitSelection[type].TraitList:GetWidth()-50,32);
				tmpRow.Caption:SetPosition(50,0);
				tmpRow.Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
				tmpRow.Caption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
				tmpRow.Caption:SetText(Trait[self.Alignment][type][subCat][traitIndex][2]);
				tmpRow.Caption:SetMouseVisible(false);
				self.TraitSelection[type].TraitList:AddItem(tmpRow);
			else
				local subClass;

				local tmpRow=Turbine.UI.Control()
				tmpRow:SetParent(self.TraitSelection[type].TraitList)
				tmpRow:SetSize(self.TraitSelection[type].TraitList:GetWidth(),33)
				tmpRow.Caption=Turbine.UI.Label();
				tmpRow.Caption:SetParent(tmpRow);
				tmpRow.Caption:SetSize(self.TraitSelection[type].TraitList:GetWidth(),32);
				tmpRow.Caption:SetPosition(0,0);
				tmpRow.Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
				tmpRow.Caption:SetFont(Turbine.UI.Lotro.Font.Verdana20);
				tmpRow.Caption:SetText(Trait[self.Alignment][type][subCat][traitIndex].Name);
				tmpRow.Caption:SetMouseVisible(false);
				self.TraitSelection[type].TraitList:AddItem(tmpRow);

				for subClass=1,#Trait[self.Alignment][type][subCat][traitIndex] do
					-- we are in the Freep Class Traits and need to iterate through the trait "lines"
					local tmpRow=Turbine.UI.Control()
					tmpRow:SetParent(self.TraitSelection[type].TraitList)
					tmpRow:SetSize(self.TraitSelection[type].TraitList:GetWidth(),33)
					tmpRow.TraitID=Trait[self.Alignment][type][subCat][traitIndex][subClass][1];
					tmpRow.SubClass=traitIndex; -- yeah, a little confusing, since the index meaning changes :( I don't really like this design but it's what it is
					tmpRow.Checked=Turbine.UI.Lotro.CheckBox();
					tmpRow.Checked:SetParent(tmpRow);
					tmpRow.Checked:SetSize(self.TraitSelection[type].TraitList:GetWidth(),32);
					tmpRow.Checked:SetPosition(0,0);
					tmpRow.Checked.TabIndex=type;
					tmpRow.Checked:SetChecked(false); -- a tad redundant but doesn't hurt
					tmpRow.Checked.CheckedChanged=function(sender)
						if not self.LoadingSelections then
							if sender:IsChecked() then
								self.TraitSelection[sender.TabIndex].NumberSelected=self.TraitSelection[sender.TabIndex].NumberSelected+1;
								if self.TraitSelection[sender.TabIndex].NumberSelected>self.Slots[self.Alignment][sender.TabIndex] then
									sender:SetChecked(false);
								else
									self.TraitSelection[sender.TabIndex].Caption:SetText(Trait[self.Alignment][sender.TabIndex].Name.." "..Resource[language][339].." ("..tostring(self.TraitSelection[sender.TabIndex].NumberSelected).."/"..tostring(self.Slots[self.Alignment][sender.TabIndex])..")"); -- number selected/number slots
								end
							else
								self.TraitSelection[sender.TabIndex].NumberSelected=self.TraitSelection[sender.TabIndex].NumberSelected-1;
								self.TraitSelection[sender.TabIndex].Caption:SetText(Trait[self.Alignment][sender.TabIndex].Name.." "..Resource[language][339].." ("..tostring(self.TraitSelection[sender.TabIndex].NumberSelected).."/"..tostring(self.Slots[self.Alignment][sender.TabIndex])..")"); -- number selected/number slots
							end
						end
					end
					tmpRow.Icon=Turbine.UI.Control();
					tmpRow.Icon:SetParent(tmpRow);
					tmpRow.Icon:SetSize(32,32);
					tmpRow.Icon:SetPosition(17,0);
					if Trait[self.Alignment][type][subCat][traitIndex][subClass][3]~=nil and Trait[self.Alignment][type][subCat][traitIndex][subClass][3]>0 then
						tmpRow.Icon:SetBackground(Trait[self.Alignment][type][subCat][traitIndex][subClass][3]);
					else
						tmpRow.Icon:SetBackground(0x410d461e);
					end
					tmpRow.Icon:SetMouseVisible(false);
					tmpRow.Caption=Turbine.UI.Label();
					tmpRow.Caption:SetParent(tmpRow);
					tmpRow.Caption:SetSize(self.TraitSelection[type].TraitList:GetWidth()-50,32);
					tmpRow.Caption:SetPosition(50,0);
					tmpRow.Caption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
					tmpRow.Caption:SetFont(Turbine.UI.Lotro.Font.Verdana18);
					tmpRow.Caption:SetText(Trait[self.Alignment][type][subCat][traitIndex][subClass][2]);
					tmpRow.Caption:SetMouseVisible(false);
					self.TraitSelection[type].TraitList:AddItem(tmpRow);
				end
			end
		end

		-- set the state before setting the event handler so we don't fire it when setting state initially
		local tmpIndex;
		local checked;
		local numberSelected=0;
		-- clear all of the checkboxes and reset the number selected to 0;
		self.LoadingSelections=true; -- we use this flag to disable the CheckedChanged event in the selection lists
		for tmpIndex=1,self.TraitSelection[type].TraitList:GetItemCount() do
			local tmpRow=self.TraitSelection[type].TraitList:GetItem(tmpIndex);
			if tmpRow.Checked~=nil then
				tmpRow.CurrentTier=nil;
				local tmpTraitIndex,checked;
				checked=false;
				if SlottedTraits[self.characterName]~=nil then
					for tmpTraitIndex=1,#SlottedTraits[self.characterName] do
						if SlottedTraits[self.characterName][tmpTraitIndex][3]==tmpRow.TraitID then
							checked=true;
							tmpRow.CurrentTier=SlottedTraits[self.characterName][tmpTraitIndex][5];
							numberSelected=numberSelected+1;
							break;
						end
					end
				end
				tmpRow.Checked:SetChecked(checked); -- this will fire the checkedchanged event but is harmless since the flag disables the counter update
			end
		end
		self.TraitSelection[type].NumberSelected=numberSelected;
		self.TraitSelection[type].Caption:SetText(Trait[self.Alignment][type].Name.." "..Resource[language][339].." ("..tostring(numberSelected).."/"..tostring(self.Slots[self.Alignment][type])..")"); -- number selected/number slots
		self.LoadingSelections=false; -- we use this flag to disable the CheckedChanged event in the selection lists
		self.TraitSelection[type]:SetVisible(true);
	end

	self:SetVisible(false);

	self.IsValid=function()
		return (self.characterIndex>1);
	end
	self.LoadPanelData=function(sender, characterName)
		self.characterName=characterName;
		local tmpIndex;
		for tmpIndex=1,#characterListArray do
			if characterListArray[tmpIndex][1]==characterName then
				self.characterIndex=tmpIndex;
				self.Alignment=characterListArray[tmpIndex][9];
				if inventoryWindow~=nil and inventoryWindow.PanelShowing==self.Index then
					self:SetVisible(self:IsValid())
				end
				break;
			end
		end

		for tmpIndex=1,4 do
			self.TraitSelection[tmpIndex]:SetVisible(false); -- hide the trait selction window if it was open
			--remove all of the prior rows - we have to do this because there are a different # of rows for Freeps and Creeps
			self.Tab[tmpIndex].Equipped:ClearItems();
			self.Tab[tmpIndex].Button:SetText(Trait[self.Alignment][tmpIndex].Name);

			local tmpSlot;
			for tmpSlot=1,self.Slots[self.Alignment][tmpIndex] do
				local tmpRow=Turbine.UI.Control();
				tmpRow:SetParent(self.Tab[tmpIndex].Equipped);
				tmpRow:SetSize(self.Tab[tmpIndex].Equipped:GetWidth(),34);
				tmpRow:SetBackColor(tabcolor[tmpIndex]);
				tmpRow.Icon=Turbine.UI.Control();
				tmpRow.Icon:SetParent(tmpRow);
				tmpRow.Icon:SetSize(32,32);
				tmpRow.Icon:SetPosition(1,1);
				tmpRow.Icon:SetMouseVisible(false);
				tmpRow.Tier=Turbine.UI.Label();
				tmpRow.Tier:SetParent(tmpRow.Icon);
				tmpRow.Tier:SetSize(16,14);
				tmpRow.Tier:SetPosition(13,17);
				tmpRow.Tier:SetFont(Turbine.UI.Lotro.Font.Verdana14);
				tmpRow.Tier:SetForeColor(Turbine.UI.Color(1,1,1));
				tmpRow.Tier:SetOutlineColor(Turbine.UI.Color(0,0,0));
				tmpRow.Tier:SetFontStyle(Turbine.UI.FontStyle.Outline);
				tmpRow.Tier:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight);
				tmpRow.Tier:SetText("1");
				tmpRow.Tier:SetMouseVisible(false);
				tmpRow.Tier:SetVisible(false);
				tmpRow.Up=Turbine.UI.Control();
				tmpRow.Up:SetParent(tmpRow);
				tmpRow.Up:SetSize(10,10);
				tmpRow.Up:SetPosition(34,1);
				tmpRow.Up:SetVisible(false);
				tmpRow.Up:SetBackground(0x4100028c);
				tmpRow.Up.MouseEnter=function()
					tmpRow.Up:SetBackground(0x4100028d);
				end
				tmpRow.Up.MouseLeave=function()
					tmpRow.Up:SetBackground(0x4100028c);
				end
				tmpRow.Up.MouseClick=function(sender,args)
					local row=sender:GetParent();
					local maxTier=row.maxTier;
					local tier=tonumber(row.Tier:GetText())+1;

					if maxTier==nil or tier<=maxTier then
						SlottedTraits[self.characterName][row.traitIndex][5]=tier;
						row.Tier:SetText(tier);
					end
				end

				tmpRow.Down=Turbine.UI.Control();
				tmpRow.Down:SetParent(tmpRow);
				tmpRow.Down:SetSize(10,10);
				tmpRow.Down:SetPosition(34,22);
				tmpRow.Down:SetVisible(false);
				tmpRow.Down:SetBackground(0x4100028e);
				tmpRow.Down.MouseEnter=function()
					tmpRow.Down:SetBackground(0x4100028f);
				end
				tmpRow.Down.MouseLeave=function()
					tmpRow.Down:SetBackground(0x4100028e);
				end
				tmpRow.Down.MouseClick=function(sender,args)
					local row=sender:GetParent();
					local tier=tonumber(row.Tier:GetText())-1;

					if tier>0 then
						SlottedTraits[self.characterName][row.traitIndex][5]=tier;
						row.Tier:SetText(tier);
					end
				end

				tmpRow.Name=Turbine.UI.Label();
				tmpRow.Name:SetParent(tmpRow);
				tmpRow.Name:SetSize(self.Tab[tmpIndex].Equipped:GetWidth()-34,32);
				tmpRow.Name:SetPosition(34,1);
				tmpRow.Name:SetBackColor(Turbine.UI.Color(0,0,0));
				tmpRow.Name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
				self.Tab[tmpIndex].Equipped:AddItem(tmpRow);
			end
		end

		local blankIndex={1,1,1,1};
		if SlottedTraits[characterName]~=nil then
			local traitIndex;
			for traitIndex=1,#SlottedTraits[characterName] do
				local type, cat, id, subcat, tier=SlottedTraits[characterName][traitIndex][1],SlottedTraits[characterName][traitIndex][2],SlottedTraits[characterName][traitIndex][3],SlottedTraits[characterName][traitIndex][4],SlottedTraits[characterName][traitIndex][5];
				local name,icon,examID,maxTier;
				-- each entry will have a Type, Category, ID and SubCategory -- we look up the Name, Icon, and ExamID in case the Trait.lua file was updated
				if subcat==nil then
					local index;
					for index=1,#Trait[self.Alignment][type][cat] do
						if Trait[self.Alignment][type][cat][index][1]==id then
							name=Trait[self.Alignment][type][cat][index][2];
							icon=Trait[self.Alignment][type][cat][index][3];
							examID=Trait[self.Alignment][type][cat][index][4];
							maxTier=Trait[self.Alignment][type][cat][index][5];
							break
						end
					end
				else
					local index;
					for index=1,#Trait[self.Alignment][type][cat][subcat] do
						if Trait[self.Alignment][type][cat][subcat][index][1]==id then
							name=Trait[self.Alignment][type][cat][subcat][index][2];
							icon=Trait[self.Alignment][type][cat][subcat][index][3];
							examID=Trait[self.Alignment][type][cat][subcat][index][4];
							maxTier=Trait[self.Alignment][type][cat][subcat][index][5];
							break
						end
					end
				end
				if name~=nil then
					-- we found a matching Trait
					-- now fill in the first blank list entry on the Type tab
					local listIndex=blankIndex[type];
					blankIndex[type]=blankIndex[type]+1;
					if icon~=nil and icon>0 then
						self.Tab[type].Equipped:GetItem(listIndex).Icon:SetBackground(icon);
					else
						self.Tab[type].Equipped:GetItem(listIndex).Icon:SetBackground(0x410d461e);
					end
					self.Tab[type].Equipped:GetItem(listIndex).Name:SetText(name);
					self.Tab[type].Equipped:GetItem(listIndex).maxTier=maxTier;
					self.Tab[type].Equipped:GetItem(listIndex).traitIndex=traitIndex;
					if maxTier~=nil then
						if tier==nil then
							tier=1;
							SlottedTraits[characterName][traitIndex][5]=1;
						end
						self.Tab[type].Equipped:GetItem(listIndex).Icon:SetMouseVisible(true);
						self.Tab[type].Equipped:GetItem(listIndex).Up:SetVisible(true);
						self.Tab[type].Equipped:GetItem(listIndex).Down:SetVisible(true);
						self.Tab[type].Equipped:GetItem(listIndex).Name:SetLeft(44);
						self.Tab[type].Equipped:GetItem(listIndex).Name:SetWidth(self.Tab[type].Equipped:GetItem(listIndex):GetWidth()-44);

						self.Tab[type].Equipped:GetItem(listIndex).Tier:SetVisible(true);
						self.Tab[type].Equipped:GetItem(listIndex).Tier:SetText(tier);
					else
						self.Tab[type].Equipped:GetItem(listIndex).Icon:SetMouseVisible(false);
						self.Tab[type].Equipped:GetItem(listIndex).Tier:SetVisible(false);

						self.Tab[type].Equipped:GetItem(listIndex).Up:SetVisible(false);
						self.Tab[type].Equipped:GetItem(listIndex).Down:SetVisible(false);
						self.Tab[type].Equipped:GetItem(listIndex).Name:SetLeft(34);
						self.Tab[type].Equipped:GetItem(listIndex).Name:SetWidth(self.Tab[type].Equipped:GetItem(listIndex):GetWidth()-34);
					end
				end
			end
		end
	end

	self.SaveData=function()
		PatchDataSave( Turbine.DataScope.Server, "AltInventory_SlottedTraits",SlottedTraits);
	end

	self.RemoveCallbacks=function()
	end

	self.SizeChanged=function(sender,args)
		local newWidth=self:GetWidth();
		local newHeight=self:GetHeight();
		local tmpIndex;
		for tmpIndex=1,4 do
			self.Tab[tmpIndex]:SetSize(newWidth,newHeight);
			self.Tab[tmpIndex].Panel:SetSize(newWidth,newHeight-20);
			self.Tab[tmpIndex].Equipped:SetSize(newWidth-14,newHeight-47);
			local tmpSlot;
			for tmpSlot=1,self.Tab[tmpIndex].Equipped:GetItemCount() do
				self.Tab[tmpIndex].Equipped:GetItem(tmpSlot):SetWidth(newWidth-14);
				if self.Tab[tmpIndex].Equipped:GetItem(tmpSlot).Up:IsVisible() then
					self.Tab[tmpIndex].Equipped:GetItem(tmpSlot).Name:SetWidth(newWidth-58);
				else
					self.Tab[tmpIndex].Equipped:GetItem(tmpSlot).Name:SetWidth(newWidth-48);
				end
			end
			self.Tab[tmpIndex].VScroll:SetLeft(newWidth-13);
			self.Tab[tmpIndex].VScroll:SetHeight(newHeight-47);
			self.TraitSelection[tmpIndex]:SetSize(newWidth,newHeight);
			self.TraitSelection[tmpIndex].TraitList:SetSize(newWidth-14,newHeight-25);
			for tmpSlot=1,self.TraitSelection[tmpIndex].TraitList:GetItemCount() do
				self.TraitSelection[tmpIndex].TraitList:GetItem(tmpSlot):SetWidth(newWidth-14);
				if self.TraitSelection[tmpIndex].TraitList:GetItem(tmpSlot).Checked~=nil then
					self.TraitSelection[tmpIndex].TraitList:GetItem(tmpSlot).Checked:SetWidth(newWidth-14);
					self.TraitSelection[tmpIndex].TraitList:GetItem(tmpSlot).Caption:SetWidth(newWidth-64);
				else
					self.TraitSelection[tmpIndex].TraitList:GetItem(tmpSlot).Caption:SetWidth(newWidth-14);
				end

			end
			self.TraitSelection[tmpIndex].VScroll:SetLeft(newWidth-13);
			self.TraitSelection[tmpIndex].VScroll:SetHeight(newHeight-25);
			self.TraitSelection[tmpIndex].CancelBtn:SetLeft(newWidth-91);
			self.TraitSelection[tmpIndex].Caption:SetWidth(newWidth-184);
		end
	end
	self.SetLanguage=function()
		local tmpIndex;
		for tmpIndex=1,4 do
			self.Tab[tmpIndex].SelectBtn:SetText(Resource[language][339]);
			self.TraitSelection[tmpIndex].OKBtn:SetText(Resource[language][19]);
			self.TraitSelection[tmpIndex].CancelBtn:SetText(Resource[language][20]);
			self.TraitSelection[tmpIndex].Caption:SetText(Trait[self.Alignment][tmpIndex].Name.." "..Resource[language][339]);
		end
	end
	self.SetTrimColor=function()
	end
	self.SetBackgroundColor=function()
	end
	self.SetListTextColor=function()
	end
	self.SetFontColor=function()
	end
	self.SetHeadingsColor=function()
	end
end
